//+------------------------------------------------------------------+
//|                                                       VATSMF.mq4 |
//|                                                         xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "xFrienDx"
#property link      "ffriend@rambler.ru"
#property indicator_chart_window

#include <TFColor.mqh>
#include <TFColorFunctions.mqh>
#include <WinUser32.mqh>

extern bool SHOW_FZR = true;
extern bool SHOW_CURRENT_WAVES = true;
extern int Y_POSITION = 70;
extern int X_POSITION = 15;
extern int NAME_SIZE = 14;
extern bool SHOW_TF = true;
extern int BEGIN_CORNER = 1;

string asFiboScale[];
string asNK[];
string asPivot[];
string asFZR[];
string asLastWaves[];
int nTotalObjects;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   PrintD("VATSMF init START:");// .  
   ResizeObjectArrays();//   ,   .
   nTotalObjects = ObjectsTotal();//  .
   PrintD("VATSMF init END:");// .
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   PrintD("VATSMF start START:");// .  
   if(nTotalObjects != ObjectsTotal())//   ,
   {
      ResizeObjectArrays();//     , ,   .
      nTotalObjects = ObjectsTotal();//  .
   }
   DelCanceledFiboForZeroBar();//   .
   CheckNKStateForZeroBar();//   .
   CheckPivotStateForZeroBar();//   .
   if(SHOW_FZR)//   ,
      CreateFZRForZeroBar();//   .

   PrintD("VATSMF start END:");// .  
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   DeleteCurrentWaves();
   return(0);
}
//+------------------------------------------------------------------+
//        .
void DeleteCurrentWaves()
{
   if(SHOW_CURRENT_WAVES)
   {
      for(int i=0; i<25;i++)
      {
         if(ObjectFind("VATSMF_CurrentWave " + i) == -1)
            continue;
         ObjectDelete("VATSMF_CurrentWave " + i);
         ObjectDelete("VATSMF_CurrentWaveArrow " + i);
         if(SHOW_TF)//   .
            ObjectDelete("VATSMF_CurrentWaveTF " + i);
      }
   }
}
//+------------------------------------------------------------------+
//       .
void ResizeObjectArrays()
{
   int i, j, k, p, f, N, nCurrentTF, nObjectVisibility;
   string sName;

   PrintD("VATSMF ResizeObjectArrays START:");// .  
   ArrayResize(asFiboScale, ObjectsTotal(OBJ_FIBO));//    .
   ArrayResize(asNK, ObjectsTotal(OBJ_TREND));//    .
   ArrayResize(asPivot, ObjectsTotal(OBJ_ARROW));//    .
   ArrayResize(asFZR, ObjectsTotal(OBJ_TREND));//    .
   DeleteCurrentWaves();
   ArrayResize(asLastWaves, 25);
   for(i = 0; i < 25; i++)
      asLastWaves[i] = "";
         
   j = 0;
   k = 0;
   p = 0;
   f = 0;
   N = ObjectsTotal();
   for(i = 0; i < N; i++)
   {
      sName = GetVATSMFObjectName(ObjectName(i), ALL);//       .
      if(sName == "")
         continue;

      nObjectVisibility = ObjectGet(sName, OBJPROP_TIMEFRAMES);//     .
      switch(Period())//     .
      {
      case 1:
         nCurrentTF = 1;
         break;
      case 5:
         nCurrentTF = 2;
         break;
      case 15:
         nCurrentTF = 4;
         break;
      case 30:
         nCurrentTF = 8;
         break;
      case 60:
         nCurrentTF = 16;
         break;
      case 240:
         nCurrentTF = 32;
         break;
      case 1440:
         nCurrentTF = 64;
         break;
      case 10080:
         nCurrentTF = 128;
         break;
      case 43200:
         nCurrentTF = 256;
         break;
      }

      if((nObjectVisibility < nCurrentTF)&&(nObjectVisibility !=0))//     ,
         continue;//      .

      if(SHOW_CURRENT_WAVES)//     .
      {
         if(GetVATSMFObjectName(sName, WAVE_LINE) != "")//      .
            LastWavesArray(sName);
      }
            
      if(ObjectType(sName) == OBJ_FIBO)// ,
      {
         sName = DelCanceledFiboForAllBars(sName);
         if(sName != "")//        .
         {
            asFiboScale[j] = sName;//    .
            j++;//    .
         }  
         continue;
      }
      
      if(GetVATSMFObjectName(sName, NK) != "")
      {
        if(ObjectGet(sName, OBJPROP_STYLE) == STYLE_DOT)//  .
        {
           asNK[k] = sName;//    .
           k++;//    .
        }
        continue;
      }
            
      if(GetVATSMFObjectName(sName, PIVOT) != "")
      {
         if(ObjectGet(sName, OBJPROP_WIDTH) != 0//  ,
          && ObjectFind(WAVE_LINE + " " + Object_Number(sName)) != -1 )//    ,   ,
         {
            sName = CheckPivotStateForAllBars(sName);//     
            if(sName != "")
            {
               asPivot[p] = sName;//     .
               p++;//    .
            }
            continue;         
         }
      }
      
      if(SHOW_FZR)//   " "
      {
         if(GetVATSMFObjectName(sName, FZR) != "" && ObjectFind(WAVE_LINE + " " + Object_Number(sName)) == -1)//  ,   , 
            ObjectDelete(sName);// .
         if(GetVATSMFObjectName(sName, WAVE_LINE) != "")//   .
         {
            if(GetWaveName(sName) == "A" || GetWaveName(sName) == "a(C)")//      ()
            {
               if(ObjectFind("FZR " + Object_Number(sName)) != -1)//     
                  if(ObjectGet("FZR " + Object_Number(sName), OBJPROP_STYLE) == STYLE_DASHDOT)//   ,
                     continue;//     .
               if(FindSameTFWave(sName, 1) != "")//    .
                  if(CreateFZRForAllBars(sName) == "")//    .
                     continue;
               asFZR[f] = sName;//     .
               f++;//    .
            }
         }
      }
      else
         if(GetVATSMFObjectName(sName, FZR) != "")//    ,
            ObjectDelete(sName);//  .
   }
   if(SHOW_CURRENT_WAVES)//     ,
      DrawCurrentWaves();//  .
      
   ArrayResize(asFiboScale, j);//    .
   ArrayResize(asNK, k);//    .
   ArrayResize(asPivot, p);//    .
   ArrayResize(asFZR, f);//    .
   PrintD("VATSMF ResizeObjectArrays END:");// .  
   return;
}
//+------------------------------------------------------------------+
//      . 
string DelCanceledFiboForAllBars(string sName)
  {
   int i, j, n, nFiboDirection, nNumFLevels, nDeleteLevel, nFiboEndShift, nDelete;
   double dFTop, dFBottom, dFMaxLevel, dFMinLevel;
   string sLastTimeBar;
   datetime dtFiboTime;
   double adFiboLevel[];
   double adFiboLevelPrice[];
   string asFiboDescription[];
   
   PrintD("VATSMF DelCanceledFiboForAllBars START: sName = " + sName);// .  
   dFTop = ObjectGet(sName, OBJPROP_PRICE1);// 100% .
   dFBottom = ObjectGet(sName, OBJPROP_PRICE2);// 0% .
   dFMinLevel = dFBottom;//  .
   if(IsFiboImpulse(sName) != FIBO_IMPULS)//  ,
      dFMinLevel =  dFBottom + (dFTop - dFBottom)*ObjectGet(sName, OBJPROP_FIRSTLEVEL);//   .

   if(dFTop > dFBottom)
      nFiboDirection = 1;//  .
   else
      nFiboDirection = -1;//  .
      
   nNumFLevels = ObjectGet(sName, OBJPROP_FIBOLEVELS);// .
   ArrayResize(adFiboLevel, nNumFLevels);//    .
   ArrayResize(adFiboLevelPrice, nNumFLevels);//     .
   ArrayResize(asFiboDescription, nNumFLevels);//    .

   n = 0;//   .
   for(i = 0; i < nNumFLevels; i++)
   {
      adFiboLevel[i] = ObjectGet(sName, OBJPROP_FIRSTLEVEL + i);//        .
      adFiboLevelPrice[i] = dFBottom + (dFTop - dFBottom)*adFiboLevel[i];//  .
      asFiboDescription[i] = ObjectGetFiboDescription(sName, i);//    .   
   }
   dFMaxLevel = dFBottom + (dFTop - dFBottom)*adFiboLevel[nNumFLevels - 1];//   .
   dtFiboTime = ObjectGet(sName, OBJPROP_TIME1);//  .
   
   if(ObjectFind(WAVE_LINE + " " + Object_Number(sName)) == -1)//         ,
      nFiboEndShift = iBarShift(Symbol(), 0, dtFiboTime, true) - 1;//           1  .
   else//   ,
      nFiboEndShift = iBarShift(Symbol(), 0, Time_(WAVE_LINE + " " + Object_Number(sName), 2), true) - 1;//     1  .
   if(nFiboEndShift > iBarShift(NULL, 0, StrToInteger(ObjectDescription(sName))))//    (  )       ,
      nFiboEndShift = iBarShift(NULL, 0, StrToInteger(ObjectDescription(sName)));//      .

   nDelete = GlobalVariableGet("NumFLevelsLeave");//     .
   ObjectSetText(sName, "");

   n = 0;//  .
   for(j = nFiboEndShift; j >= 0; j--)//   .
   {
      nDeleteLevel = nDelete;//     .
      if(nFiboDirection*(MaxMin(nFiboDirection, 0, j) - dFMinLevel) < 0)//       ,
      {
            ObjectDelete(sName);//   
            PrintD("VATSMF DelCanceledFiboForAllBars END1: sName = ");// .  
            return("");//  .
      }
      if(nFiboDirection*(MaxMin(nFiboDirection, 0, j) - dFMaxLevel) > 0)//       , 
      {
         if(IsFiboImpulse(sName) == FIBO_CORRECT)//  ,
         {
            MakeFiboImpulse(sName);//   
            PrintD("VATSMF DelCanceledFiboForAllBars END2: sName = " + sName);// .  
            return(sName);//   .
         }
         else//    ,
         {
            ObjectDelete(sName);//   
            PrintD("VATSMF DelCanceledFiboForAllBars END3: sName = ");// .  
            return("");//  .
         }
      }
      else//    ,    .
      {
         if(IsFiboImpulse(sName) == FIBO_CORRECT)// .
            for(i = 0; i < nNumFLevels; i++)
            {
               if(adFiboLevel[i] == 1 || adFiboLevel[i] == 0)//    0  100%,
               {
                  continue;//    .
               }
               if(nFiboDirection*(MaxMin(-nFiboDirection, 0, j) - adFiboLevelPrice[i]) >= 0)//       
                  continue;//    .
               else//   , 
               {
                  if(nDeleteLevel > 0)//     .
                  {
                     nDeleteLevel--;//    
                     continue;//    .
                  }
                  asFiboDescription[i] = "";//   ,      
                  n = 1;//  .
               }
            }
         if(IsFiboImpulse(sName) == FIBO_IMPULS)// .
            for(i = nNumFLevels-1; i >=0 ; i--)
            {
               if(adFiboLevel[i] == 1 || adFiboLevel[i] == 0)//   - 0  100%,
                  continue;//    .
               
               if(nFiboDirection*(MaxMin(nFiboDirection, 0, j) - adFiboLevelPrice[i]) <= 0)//       
                  continue;//    .
               else//   , 
               {
                  if(nDeleteLevel > 0)//     .
                  {
                     nDeleteLevel--;//    
                     continue;//    .
                  }
                  asFiboDescription[i] = "";//   ,      
                  adFiboLevel[i] = 0;//     0.
                  n = 1;//  .
               }
            }
      }
   }
   if(n == 0)//     ,
   {
      sLastTimeBar = iTime(NULL,0,0);//   .
      ObjectSetText(sName, sLastTimeBar);//     .
      PrintD("VATSMF DelCanceledFiboForAllBars END4: sName = " + sName);// .  
      return(sName);//   .
   }
   
   j=0;//    .
   for(i = 0; i < nNumFLevels; i++)
   {
      if(asFiboDescription[i] != "")//        , 
      {
         ObjectSet(sName, OBJPROP_FIRSTLEVEL + j, adFiboLevel[i]);//    
         ObjectSetFiboDescription(sName, j, asFiboDescription[i]);// .
         sLastTimeBar = iTime(NULL,0,0);//   .
         ObjectSetText(sName, sLastTimeBar);//     .
         j++;
      }   
   }
   ObjectSet(sName, OBJPROP_FIBOLEVELS, j);//    .
   PrintD("VATSMF DelCanceledFiboForAllBars END5: sName = " + sName);// .  
   return(sName);//  .
}
//+-----------------------------------------------------------------+
//         . 
void DelCanceledFiboForZeroBar()
{
   int i, j, n, nFiboDirection, nNumFLevels, nDeleteLevel;
   double dFTop, dFBottom, dFMaxLevel, dFMinLevel, dFiboLevelPrice;
   string sName;
      
   PrintD("VATSMF DelCanceledFiboForZeroBar START:");// .  
   n = ArraySize(asFiboScale);//   .
   for(i = 0; i < n; i++)
   {
      sName = asFiboScale[i];//    .
      if(sName == "")//  ,         .
         continue;
      dFTop = ObjectGet(sName, OBJPROP_PRICE1);// 100% .
      dFBottom = ObjectGet(sName, OBJPROP_PRICE2);// 0% .
      dFMinLevel = dFBottom;//  .
      if(IsFiboImpulse(sName) != FIBO_IMPULS)//  ,
         dFMinLevel =  dFBottom + (dFTop - dFBottom)*ObjectGet(sName, OBJPROP_FIRSTLEVEL);//   .

      if(dFTop > dFBottom)
         nFiboDirection = 1;//  .
      else
         nFiboDirection = -1;//  .
      nNumFLevels = ObjectGet(sName, OBJPROP_FIBOLEVELS);// .
      int z = nNumFLevels - 1;
      dFMaxLevel = dFBottom + (dFTop - dFBottom)*ObjectGet(sName, OBJPROP_FIRSTLEVEL + nNumFLevels-1);//   .
      if(nFiboDirection*(iClose(NULL,0,0) - dFMinLevel) < 0)//       ,
      {
         ObjectDelete(sName);//   
         asFiboScale[i] = "";//     .
      }
      if(nFiboDirection*(iClose(NULL,0,0) - dFMaxLevel) > 0)//       , 
      {   
         if(IsFiboImpulse(sName) == FIBO_CORRECT)//  ,
            MakeFiboImpulse(sName);//   
         else//    ,
         {
            ObjectDelete(sName);//   
            asFiboScale[i] = "";//     .
         }
      }
      else//    ,    .
      {
         nDeleteLevel = GlobalVariableGet("NumFLevelsLeave");//     .
         if(IsFiboImpulse(sName) == FIBO_CORRECT)// .
            for(j = 0; j < nNumFLevels; j++)
            {
               if((ObjectGet(sName, OBJPROP_FIRSTLEVEL+j) == 1)||(ObjectGet(sName, OBJPROP_FIRSTLEVEL+j) == 0))//   0  100%,
                  continue;//    .
               dFiboLevelPrice = dFBottom + (dFTop - dFBottom)*ObjectGet(sName, OBJPROP_FIRSTLEVEL+j);//  .
               if(nFiboDirection*(iClose(NULL,0,0) - dFiboLevelPrice) >= 0)//       
                  continue;//    .
               else//   , 
               {
                  if(nDeleteLevel > 0)//     .
                  {
                     nDeleteLevel--;//    
                     continue;//    .
                  }
                  ObjectSetFiboDescription(sName, j, "");//   ,    
                  ObjectSet(sName, OBJPROP_FIRSTLEVEL+j, 0);// .
               }
            }
         if(IsFiboImpulse(sName) == FIBO_IMPULS)// .
            for(j = nNumFLevels-1; j >=0 ; j--)
            {
               if((ObjectGet(sName, OBJPROP_FIRSTLEVEL+j) == 1)||(ObjectGet(sName, OBJPROP_FIRSTLEVEL+j) == 0))//   0  100%,
                  continue;//    .
               dFiboLevelPrice = dFBottom + (dFTop - dFBottom)*ObjectGet(sName, OBJPROP_FIRSTLEVEL+j);//  .
               if(nFiboDirection*(iClose(NULL,0,0) - dFiboLevelPrice) <= 0)//       
                  continue;//    .
               else//   ,
               {
                  if(nDeleteLevel > 0)//     .
                  {
                     nDeleteLevel--;//    
                     continue;//    .
                  }
                  ObjectSetFiboDescription(sName, j, "");//   ,    
                  ObjectSet(sName, OBJPROP_FIRSTLEVEL+j, 0);// .
               }
            }
      }
   }  
   PrintD("VATSMF DelCanceledFiboForZeroBar END:");// .  
   return;
}
//+------------------------------------------------------------------+
//  .
void CheckNKStateForZeroBar()
{
   int i, j, nStartBar, nEndBar, nNKDirection, nNewEndBar;
   double dStartPrice, dEndPrice, dNewEndPrice, dBarPrice;
   string sName;
   
   PrintD("VATSMF CheckNKStateForZeroBar START:");// .  
   for(i = 0; i < ArraySize(asNK); i++)
   {
      sName = asNK[i];//     .
      if(sName == "")//  ,
         continue;//    .
      if(iTime(NULL, 0, 0) - iTime(NULL, 0, 1) != 60*Period())//             ,
         break;//     .
      nNKDirection = Object_Direction(sName);// .

      if(iBarShift(NULL, Period(), Time_(sName, 2)) != 0)//      
      {
         dStartPrice = Price_(sName, 1);//   ,
         nStartBar = iBarShift(NULL, Period(), Time_(sName, 1));//  .
         
         if(ObjectDescription(sName) == "")//     ,   
         {
            dEndPrice = Price_(sName, 2);//  ,
            nEndBar = iBarShift(NULL, Period(), Time_(sName, 2));//  .
         }
         else
         {
            dEndPrice = StrToDouble(Object_Name(ObjectDescription(sName)));//     
            nEndBar = iBarShift(NULL, 0, StrToTime(Object_Number(ObjectDescription(sName))));// c .
         }
         for(j = nEndBar -1; j >= 0; j--)
         { 
            dNewEndPrice = dStartPrice + (j - nStartBar)*(dEndPrice - dStartPrice)/(nEndBar - nStartBar);//     .

            if(nNKDirection == 1)//   ,
               dBarPrice = iLow(NULL, 0, j);//     .
            else//   ,
               dBarPrice = iHigh(NULL, 0, j);//     .

            nNewEndBar = j;//  .
            if(nNKDirection*dBarPrice > nNKDirection*dNewEndPrice)//    ,
               continue;//    .
            else// , 
            {
               ObjectSet(sName, OBJPROP_STYLE, STYLE_DASHDOT);//      .
               asNK[i] = "";//      .
               break;//   .
            }
         }
         ObjectSet(sName, OBJPROP_PRICE2, dNewEndPrice);//   .
         ObjectSet(sName, OBJPROP_TIME2, iTime(NULL, 0, nNewEndBar));
      }
      else//     ,
      {
         if(nNKDirection*iClose(NULL, 0 ,0) > nNKDirection*Price_(sName, 2))//     ,
            continue;//   .
         else// ,
         {
            ObjectSet(sName, OBJPROP_STYLE, STYLE_DASHDOT);//     .
            asNK[i] = "";//      .
            continue;//   .
         }
      }
   }
   PrintD("VATSMF CheckNKStateForZeroBar END:");// .  
   return;
}
//+------------------------------------------------------------------+
//     .
string CheckPivotStateForAllBars(string sName)
{
   int i, nStartBar, nPivotDirection;
   double dPivotPrice;

   PrintD("VATSMF CheckPivotStateForAllBars START: sName = " + sName);// .  
   nStartBar = iBarShift(NULL,0,Time_(WAVE_LINE + " " + Object_Number(sName), 2));//       .
   dPivotPrice = Price_(sName, 1);//    .
   nPivotDirection = Object_Direction(WAVE_LINE + " " + Object_Number(sName));// ,    .

   for(i = nStartBar-1; i >=0; i--)//      .
   {
      if(nPivotDirection*(MaxMin(-nPivotDirection, 0, i) - dPivotPrice) < 0)//  ,
      {
         ObjectSet(sName, OBJPROP_WIDTH, 0);//       ,
         sName = "";//  
         break;//   .
      }
   }
   PrintD("VATSMF CheckPivotStateForAllBars END: sName = " + sName);// .  
   return(sName);
}
//+------------------------------------------------------------------+
//  .
void CheckPivotStateForZeroBar()
{
   int i, nPivotDirection;
   string sName;
   
   PrintD("VATSMF CheckPivotStateForZeroBar START:");// .  
   for(i = 0; i < ArraySize(asPivot); i++)
   {
      sName = asPivot[i];//     .
      if(sName == "")//  ,
         continue;//    .
      nPivotDirection = Object_Direction(WAVE_LINE + " " + Object_Number(sName));// ,    .
      if(nPivotDirection*iClose(NULL, 0 ,0) > nPivotDirection*Price_(sName, 1))//       ,
         continue;//   .
      else// ,
      {
         ObjectSet(sName, OBJPROP_WIDTH, 0);//      .
         asPivot[i] = "";//      .
      }
   }
   PrintD("VATSMF CheckPivotStateForZeroBar END:");// .  
   return;
}
//+------------------------------------------------------------------+
//    .
string CreateFZRForAllBars(string sName)
{
   int j, nWaveDirection, nFZRStart, nFZREnd;
   double dFZRPrice;
   string sFZRName;
   
   PrintD("VATSMF CreateFZRForAllBars START: sName = " + sName);// .  
   sFZRName = "FZR " + Object_Number(sName);// .
   nWaveDirection = Object_Direction(sName);// .
   dFZRPrice = Price_(sName, 2);//  
   nFZRStart = iBarShift(NULL,0,Time_(sName, 2));//    
   j=nFZRStart+1;
   if(ObjectFind(sFZRName) == -1)//      .
   {
      ObjectCreate(sFZRName, OBJ_TREND, ObjectFind(sName),Time_(sName, 2), dFZRPrice,Time_(sName, 2),dFZRPrice);//    .
      ObjectSet(sFZRName, OBJPROP_STYLE, STYLE_DOT);
      SetObjectColor(sFZRName, ObjectGet(sName,OBJPROP_COLOR));
      ObjectSet(sFZRName, OBJPROP_RAY, false);
   }
   while(true)
   {
//       Print("j=", TimeToStr(iTime(NULL,0,j)));
      j--;
      nFZREnd = j;// .
      if(nWaveDirection*(dFZRPrice - MaxMin(nWaveDirection, 0, j))<0)//     ,
      {
         ObjectSet(sFZRName, OBJPROP_TIME2, iTime(NULL,0, nFZREnd));//  .
         ObjectSet(sFZRName, OBJPROP_STYLE, STYLE_DASHDOT);//  .
         PrintD("VATSMF CreateFZRForAllBars END1:");// .  
         return("");
      }
      if(j == 0)//   ,    .
      {
         ObjectSet(sFZRName, OBJPROP_TIME2, iTime(NULL,0,nFZREnd));//    .
         PrintD("VATSMF CreateFZRForAllBars END2: sFZRName = " + sFZRName);// .  
         return(sFZRName);
      }
   }
}
//+------------------------------------------------------------------+
//    .
void CreateFZRForZeroBar()
{
   int i, nWaveDirection;
      
   PrintD("VATSMF CreateFZRForZeroBar START:");// .  
   for(i=0; i < ArraySize(asFZR); i++)
   {
      if(asFZR[i] == "")//  ,
         continue;//   
      nWaveDirection = Object_Direction(asFZR[i]);// .
  //       Print("j=", TimeToStr(iTime(NULL,0,j)));

      if(nWaveDirection*(ObjectGet(asFZR[i], OBJPROP_PRICE2) - MaxMin(nWaveDirection, 0, 0))<0)
      {
         ObjectSet("FZR " + Object_Number(asFZR[i]), OBJPROP_TIME2, iTime(NULL,1,0));
         ObjectSet("FZR " + Object_Number(asFZR[i]), OBJPROP_STYLE, STYLE_DASHDOT);
//         ObjectSet("FZR " + Object_Number(asFZR[i]), OBJPROP_WIDTH, 3);
         asFZR[i] = "";
      }
   }
   PrintD("VATSMF CreateFZRForZeroBar END:");// .  
}
//+------------------------------------------------------------------+
//         .
void LastWavesArray(string sName)
{
   int n;
   
   PrintD("VATSMF LastWavesArray START: sName = " + sName);// .  
   if(ObjectGet(sName, OBJPROP_STYLE) != STYLE_SOLID)//    ,
      return;//  .
   if(ObjectFind(WAVE_NAME + " " + Object_Number(sName)) == -1)//   ,
      return;//  .
   if(GetWaveName(sName) == " ")//    ,
      return;//  .
   //    .
   for(n = 0; n < ArraySize(ALL_TF); n++)
   {//       
      if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) == ALL_TF[n])//   ,
         break;//  ""      .
   }
   if(asLastWaves[n] == "")//    ,
      asLastWaves[n] = sName;//     .

   else
      if(ObjectGet(sName, OBJPROP_TIME1) > ObjectGet(asLastWaves[n], OBJPROP_TIME1))//           ,
         asLastWaves[n] = sName;//     .
   PrintD("VATSMF LastWavesArray END:      n = " + n);// .  
}
//+------------------------------------------------------------------+
//   .
void DrawCurrentWaves()
{
   int i, j, n, nShift;
   bool bFindNotEmpty;
   string sLabelWaveName, sLabelWaveTF, sLabelWaveArrow, sWaveName;

   PrintD("VATSMF DrawCurrentWaves() START:");// .  
   n=24;
   for(i = 24; i >= 0; i--)//      .
   {
      if(asLastWaves[i] == "")//   
      {
         if(n > i)
            n=i-1;
         bFindNotEmpty = false;//      
         for(j=n; j >= 0; j--)//    .
         {
            if(asLastWaves[j] != "")//   
            {
               n = j;//     .
               bFindNotEmpty = true;//      .
               break; 
            }
         }
         if(!bFindNotEmpty)//      ,
         {
            n=i+1;//    .
            i = 0;
            for(j=n; j < 25; j++)//       .
            {
               asLastWaves[i] = asLastWaves[j];
               i++;  
            }
            ArrayResize(asLastWaves, i);
            break;//    .
         }
         asLastWaves[i] = asLastWaves[n];//     .
         asLastWaves[n] = "";//  .
      }
      if(i != 24)
      {
         if(Time_(asLastWaves[i], 1) - Time_(asLastWaves[i+1], 2) < -180*Period())//           ,
         {
            asLastWaves[i] = "";//    
            i=i+1;//     ,  , ,      .
         }
      }
   }
   
   n = ArraySize(asLastWaves)-1;
   
   for(i = n; i >= 0; i--)//    
   {
      sLabelWaveArrow = "VATSMF_CurrentWaveArrow " + i;
      ObjectCreate(sLabelWaveArrow, OBJ_LABEL, 0, 0, 0);
      ObjectSet(sLabelWaveArrow, OBJPROP_CORNER, BEGIN_CORNER);
      ObjectSet(sLabelWaveArrow, OBJPROP_XDISTANCE, X_POSITION);
      ObjectSet(sLabelWaveArrow, OBJPROP_YDISTANCE, Y_POSITION + (n - i)*1.4*NAME_SIZE);
      ObjectSet(sLabelWaveArrow, OBJPROP_BACK, true);
      if(Object_Direction(asLastWaves[i]) == 1)//   
         ObjectSetText(sLabelWaveArrow, "", NAME_SIZE, "Wingdings", Red);
      else
         ObjectSetText(sLabelWaveArrow, "", NAME_SIZE, "Wingdings", Blue);
      
      nShift = 1.7*NAME_SIZE;
      if(SHOW_TF)//   .
      {
         sLabelWaveTF = "VATSMF_CurrentWaveTF " + i;
         ObjectCreate(sLabelWaveTF, OBJ_LABEL, 0, 0, 0);
         ObjectSet(sLabelWaveTF, OBJPROP_CORNER, BEGIN_CORNER);
         ObjectSet(sLabelWaveTF, OBJPROP_XDISTANCE, X_POSITION + 1.5*NAME_SIZE);
         ObjectSet(sLabelWaveTF, OBJPROP_YDISTANCE, Y_POSITION + (n - i)*1.4*NAME_SIZE);
         ObjectSet(sLabelWaveTF, OBJPROP_BACK, true);
         ObjectSetText(sLabelWaveTF, GetTFNameByColor(ObjectGet(asLastWaves[i], OBJPROP_COLOR)), NAME_SIZE, "Arial", ObjectGet(asLastWaves[i], OBJPROP_COLOR));
         nShift = 4.5*NAME_SIZE;
      }
      
      sLabelWaveName = "VATSMF_CurrentWave " + i;
      ObjectCreate(sLabelWaveName, OBJ_LABEL, 0, 0, 0);
      ObjectSet(sLabelWaveName, OBJPROP_CORNER, BEGIN_CORNER);
      ObjectSet(sLabelWaveName, OBJPROP_XDISTANCE, X_POSITION + nShift);
      ObjectSet(sLabelWaveName, OBJPROP_YDISTANCE, Y_POSITION + (n - i)*1.4*NAME_SIZE);
      ObjectSet(sLabelWaveName, OBJPROP_BACK, true);
      sWaveName = GetWaveName(asLastWaves[i]);
      ObjectSetText(sLabelWaveName, GetCurrentWaveName(GetWaveName(asLastWaves[i])), NAME_SIZE, "Arial", ObjectGet(asLastWaves[i], OBJPROP_COLOR));
   }
   PrintD("VATSMF DrawCurrentWaves() START:");// .  
}
//+------------------------------------------------------------------+
//     .
string GetCurrentWaveName(string sWaveName)
{
   PrintD("VATSMF GetCurrentWaveName START:  sWaveName = " + sWaveName);// .  
   if(sWaveName == "A")
      return("B");
   if(sWaveName == "B")
      return("a(C)/C");
   if(sWaveName == "C")
      return("4/A");
   if(sWaveName == "4")
      return("5");
   if(sWaveName == "5")
      return("A");
   if(sWaveName == "a(C)")
      return("b(C)");
   if(sWaveName == "b(C)")
      return("c(C)");
   if(sWaveName == "c(C)")
      return("4(C)/4");
   if(sWaveName == "4(C)")
      return("5(C)");
   if(sWaveName == "5(C)")
      return("4/A");
   PrintD("VATSMF GetCurrentWaveName END:");// .  
}


