//+------------------------------------------------------------------+
//|                                                      TFColor.mq4 |
//|                                                         xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "xFrienDx"
#property link      "ffriend@rambler.ru"
#property library

//       troshenkin@bk.ru
//   : 
//datetime GetExectTLTime(datetime dtTime, double nPrice, int nDirection)
//int IsFiboImpulse(string sName)

#include <stdlib.mqh>
#include <TFColor.mqh>
#include <WinUser32.mqh>
#import "user32.dll"
int GetAsyncKeyState  (int button);
#import "kernel32.dll"
int WinExec(uchar &lpCmdLine[], int uCmdShow);
#import

//+--------------------------------------------------------------------------------------+
//|                                                                |
//+--------------------------------------------------------------------------------------+

//            ( ,
// ,  , , )      ,   .
//         ,   .       LL.
string GetVATSMFObjectName(string sName, string sType)
{
   int nObjType;
   string sTypeName;

   //PrintD("GetVaTsMfObjectName START: sName = " + sName); 
   nObjType = ObjectType(sName);//  
   sTypeName = Object_Name(sName);//           .
   if(nObjType == OBJ_TREND && sTypeName == WAVE_LINE && (sType == WAVE_LINE || sType == ALL))//    ,
      return(sName);//   .
   if(nObjType == OBJ_TEXT && sTypeName == WAVE_NAME && (sType == WAVE_NAME || sType == ALL))//    ,
      return(sName);//   .
   if(nObjType == OBJ_TREND && sTypeName == NK && (sType == NK || sType == ALL))//     ,
      return(sName);//   .
   if(nObjType == OBJ_TREND && sTypeName == FZR && (sType == FZR || sType == ALL))//    ,
      return(sName);//   .
   if(nObjType == OBJ_ARROW && (ObjectGet(sName, OBJPROP_ARROWCODE) == SYMBOL_RIGHTPRICE) && sTypeName == PIVOT && (sType == PIVOT || sType == ALL))//     ,
      return(sName);//   .
   if(nObjType == OBJ_FIBO && sTypeName == FIBO_SCALE && (sType == FIBO_SCALE || sType == ALL))// ,
      return(sName);//   .
   if(nObjType == OBJ_RECTANGLE && sTypeName == TARGET && (sType == TARGET || sType == ALL))//   ,
      return(sName);//   .
   //PrintD("GetVaTsMfObjectName END2:       ");//         .
   return("");
}
//+--------------------------------------------------------------------------------------+
//      .
string Object_Name(string sName)
{
   //PrintD("Object_Name START: sName = " + sName);
   int nSpaceIndex = StringFind(sName, " ", 1);//     .
 
   if(nSpaceIndex == -1)//   ,  ,              .
   {
      //PrintD("Object_Name END1: sName = " + sName);//              .
      return(sName);//    .
   }
   //PrintD("Object_Name END2: sName = " + StringSubstr(sName, 0, nSpaceIndex));//      .
   return(StringSubstr(sName, 0, nSpaceIndex));//    ,       .
}
//+--------------------------------------------------------------------------------------+
//             ,    .
string Object_Number(string sName)
{
   int nSpaceIndex = StringFind(sName, " ", 1);//     .
   if(nSpaceIndex == -1)//   ,
      return("");//   .
   return(StringSubstr(sName, nSpaceIndex + 1, StringLen(sName) - nSpaceIndex));//  ,      .
}
//+--------------------------------------------------------------------------------------+
//             .
string GetWaveName(string sName)
{
   string sNum, sWaveName, sTextName;

   sNum = Object_Number(sName);
   if (sNum == "")
      return("");

   sTextName = WAVE_NAME + " " + sNum;

   if(ObjectFind(sTextName) == -1)
      return("");
   
   sWaveName = Object_Name(ObjectDescription(sTextName));
      
   return (sWaveName);
}
//+--------------------------------------------------------------------------------------+
//    . n <= 1   , n >= 2 - .
double Price_(string sName, int n)
{
   if(n <= 1)
      return(ObjectGet(sName, OBJPROP_PRICE1));//  PRICE1.
   else
      return(ObjectGet(sName, OBJPROP_PRICE2));//  PRICE2.
}
//+--------------------------------------------------------------------------------------+
//    . n <= 1   , n >= 2 - .
datetime Time_(string sName, int n)
{
   if(n <= 1)
      return(ObjectGet(sName, OBJPROP_TIME1));//  PRICE1.
   else
      return(ObjectGet(sName, OBJPROP_TIME2));//  PRICE2.
}
//+--------------------------------------------------------------------------------------+
//       .    ,    "1",  - "-1",    "0".
int Object_Direction(string sName)
{  
   PrintD("Object_Direction START: sName = " + sName);// .

   if(ObjectType(sName) == OBJ_TREND)//    ,   .
   {
      if(ObjectGet(sName, OBJPROP_PRICE1) < ObjectGet(sName, OBJPROP_PRICE2))//        -     .
         return(1);
      else if(ObjectGet(sName, OBJPROP_PRICE1) > ObjectGet(sName, OBJPROP_PRICE2))//        -     .
         return(-1);
      else//  ,   "0".
         return(0);
   }
   if(ObjectType(sName) == OBJ_FIBO)//   ,   .
   {
      if(ObjectGet(sName, OBJPROP_PRICE1) < ObjectGet(sName, OBJPROP_PRICE2))//        -     .
         return(-1);
      else if(ObjectGet(sName, OBJPROP_PRICE1) > ObjectGet(sName, OBJPROP_PRICE2))//        -     .
         return(1);
      else//  ,   "0".
         return(0);
   } 
   return(0);//       ,    "0".
}
//+--------------------------------------------------------------------------------------+
//              RefreshObjectsViewOneTF
//  : 1)         TFColorConfig.mgh; 2)      
//;3)        .
void SetObjectVisibleOnTF(string sName)
{
   int nObjTF;
   color clObjColor;

   PrintD("SetObjectVisibleOnTF START: sName = " + sName);// .
   clObjColor = ObjectGet(sName, OBJPROP_COLOR);//  .
   if (ObjectType(sName) == OBJ_FIBO)//  ,
      clObjColor = ObjectGet(sName, OBJPROP_LEVELCOLOR);//    .

   nObjTF = GetTFByColor(clObjColor);//    .
   if(ObjectFind("ObjectsViemOneTF") == -1)
      ObjectSet(sName, OBJPROP_TIMEFRAMES, GetShownTFsByColor(clObjColor));

   else
   {
      if(ObjectGet("ObjectsViemOneTF", OBJPROP_COLOR) == Red)
      {
         if (nObjTF >= PERIOD_MN1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 511);       
         if (nObjTF >= PERIOD_W1 && nObjTF < PERIOD_MN1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 255);       
         if (nObjTF >= PERIOD_D1 && nObjTF < PERIOD_W1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 127);       
         if (nObjTF >= PERIOD_H4 && nObjTF < PERIOD_D1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 63);       
         if (nObjTF >= PERIOD_H1 && nObjTF < PERIOD_H4)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 31);       
         if (nObjTF >= PERIOD_M15 && nObjTF < PERIOD_H1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 15);       
         if (nObjTF >= PERIOD_M5 && nObjTF < PERIOD_M15)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 3);       
         if (nObjTF >= PERIOD_M1 && nObjTF < PERIOD_M5)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 1);    
      }
      else
      {
         if (nObjTF >= PERIOD_W1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 511);       
         if (nObjTF >= PERIOD_D1 && nObjTF < PERIOD_W1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 255);       
         if (nObjTF >= PERIOD_H4 && nObjTF < PERIOD_D1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 127);       
         if (nObjTF >= PERIOD_H1 && nObjTF < PERIOD_H4)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 63);       
         if (nObjTF >= PERIOD_M15 && nObjTF < PERIOD_H1)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 31);       
         if (nObjTF >= PERIOD_M5 && nObjTF < PERIOD_M15)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 15);       
         if (nObjTF >= PERIOD_M1 && nObjTF < PERIOD_M5)
            ObjectSet(sName, OBJPROP_TIMEFRAMES, 3);    
      }   
   }
   return;
}
//+--------------------------------------------------------------------------------------+
//        .
int GetShownTFsByColor(color clColor)
{
   PrintD("GetShownTFsByColor START: clColor = " + clColor);// .
   //    .
   for(int i = 0; i < ArraySize(ALL_TF_COLOR); i++)
   {//          
      if(clColor == ALL_TF_COLOR[i])//   ,
         return(SHOW_ON_TF[i]);//       ,    ,     .
   }

   return(0);//     0.
}
//+--------------------------------------------------------------------------------------+
//        .
int GetTFByColor(color clColor)
{
   //    .
   for(int i = 0; i < ArraySize(ALL_TF_COLOR); i++)
   {//          
      if(clColor == ALL_TF_COLOR[i])//   ,
         return(ALL_TF[i]);//      ,    ,     .
   }

   return(0);//     0.
}
//+--------------------------------------------------------------------------------------+
//        .
color GetColorByTF(int nTimeFrame)
{
   //    .
   for(int i = 0; i < ArraySize(ALL_TF); i++)
   {//          
      if(nTimeFrame == ALL_TF[i])//   ,
         return(ALL_TF_COLOR[i]);//      ,    ,     .
   }

   return(0xFFFFFF);//       .
}
//+--------------------------------------------------------------------------------------+
//        .
color GetColorByTFName(string sName)
{
   //    .
   for(int i = 0; i < ArraySize(ALL_TF_NAME); i++)
   {//          
      if(sName == ALL_TF_NAME[i])//    ,
         return(ALL_TF_COLOR[i]);//      ,    ,      .
   }

   return(0xFFFFFF);//       .
}
//+--------------------------------------------------------------------------------------+
//      .
string GetTFName(int nTimeFrame)
{
   //    .
   for(int i = 0; i < ArraySize(ALL_TF); i++)
   {//          
      if(nTimeFrame == ALL_TF[i])//   ,
         return(ALL_TF_NAME[i]);//      ,    ,     .
   }

   return("");//      .
}
//+--------------------------------------------------------------------------------------+
//       .
string GetTFNameByColor(color clColor)
{
   //    .
   for(int i = 0; i < ArraySize(ALL_TF_COLOR); i++)
   {//          
      if(clColor == ALL_TF_COLOR[i])//   ,
         return(ALL_TF_NAME[i]);//      ,    ,     .
   }

   return("");//      .
}
//+--------------------------------------------------------------------------------------+
//   ,    
// ,          -
// .
void SetObjectColor(string sName, color clColor)
{
   PrintD("SetObjectColor START: sName = " + sName + ", clColor = " + clColor);// .

   if (sName != "")
   {
      int nObjType = ObjectType(sName);//  .
      ObjectSet(sName, OBJPROP_COLOR, clColor);//  .
      
      if (nObjType == OBJ_FIBO)//  ,
      {   
         ObjectSet(sName, OBJPROP_COLOR, clColor);//  .
         ObjectSet(sName, OBJPROP_LEVELCOLOR, clColor);//    .
      }
         
      SetObjectVisibleOnTF(sName);//     .
      WindowRedraw();
   }
}
//+--------------------------------------------------------------------------------------+
//         .
void AdjustTrendLine(string sName)
{
   int nDirection;
   datetime dtTLStart, dtTLEnd;
   double nTLTop, nTLBottom;

   PrintD("AdustTrendLine START: sName = " + sName);// .
   if(ObjectType(sName) != OBJ_TREND)//     ,   .
   {
      PrintD("AdjustTrendLine END1: O " + sName + "    !");// .
      return;
   }
   //    1
   //      
   dtTLStart = ObjectGet(sName, OBJPROP_TIME1);//  .
   dtTLEnd = ObjectGet(sName, OBJPROP_TIME2);
   nTLBottom = ObjectGet(sName, OBJPROP_PRICE1);
   nTLTop = ObjectGet(sName, OBJPROP_PRICE2);
   nDirection = Object_Direction(sName);// .
   //       

   ObjectSet(sName, OBJPROP_TIME1, GetExectTLTime(dtTLStart, nTLBottom, - nDirection));
   ObjectSet(sName, OBJPROP_TIME2, GetExectTLTime(dtTLEnd, nTLTop, nDirection));
   PrintD("AdjustTrendLine END2:");// .
   return;
}
//+--------------------------------------------------------------------------------------+
//       .
datetime GetExectTLTime(datetime dtTime, double nPrice, int nDirection)
{
   int i, nEndBar, nStartBar, nAdjustPeriod, nFoundBar;
   datetime dtResult = dtTime;
   
   PrintD("GetExectTLTime START: dtTime = " + dtTime + ", nPrice = " + nPrice + ", nDirection = " + nDirection);//  .
   nStartBar = -1;//  .
   nAdjustPeriod = -1;

   for(i=0; i < ArraySize(REAL_TF); i++)//        
   {
      if (REAL_TF[i] == Period())//    ,
         break;//   .

      PrintD(REAL_TF[i] + " " + iBars(Symbol(), REAL_TF[i]) + " " + TimeToStr(iTime(Symbol(), REAL_TF[i], iBars(Symbol(), REAL_TF[i])-1)));
      if (iTime(Symbol(), REAL_TF[i], iBars(Symbol(), REAL_TF[i])-1) < dtTime)//             ,
      {
         nAdjustPeriod = REAL_TF[i];//     
         break;//      1,        1    .
      }
   }
   if (nAdjustPeriod == -1)//     ,
      return (dtResult);//         ,   .

   for(i=0; i < iBars(Symbol(), nAdjustPeriod); i++)//          
   {
      if (iTime(Symbol(), nAdjustPeriod, i) < dtTime)//  
      {
         nStartBar = i;
         nEndBar = nStartBar - Period()/nAdjustPeriod;
         if (nEndBar < 0)
            nEndBar = 0;
            
         break;
      }     
   }
   
   if (nStartBar == -1)
      return (dtResult);

     PrintD(nAdjustPeriod + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nStartBar)) + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nEndBar)));

   //     nPeriod    dtCurTLEnd
   nFoundBar = -1;
   PrintD("nStartBar=" + nStartBar + " nEndBar= " + nEndBar );   
   for(i=nStartBar; i >= nEndBar; i--)
   {
      if((nDirection == 1 && (iHigh(Symbol(), nAdjustPeriod, i) == nPrice))
       ||(nDirection == -1 && (iLow(Symbol(), nAdjustPeriod, i) == nPrice)))
      {
      PrintD("iHigh(Symbol(), nAdjustPeriod, i)=" + iHigh(Symbol(), nAdjustPeriod, i) + " nPrice=" + nPrice);
         nFoundBar = i;
         //    ,  
         if (iTime(Symbol(), nAdjustPeriod, nFoundBar) == dtTime)
         {
            PrintD("Second time");
            break;
         }
      }
   }
 
     PrintD(TimeToStr(iTime(Symbol(), nAdjustPeriod, nStartBar)) + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nFoundBar)));
   if (nFoundBar != -1)
      dtResult = iTime(Symbol(), nAdjustPeriod, nFoundBar);
   PrintD("GetExectTLTime END: dtResult = " + TimeToStr(dtResult));//  .
   return (dtResult);
}
//+--------------------------------------------------------------------------------------+
//   .
int IsFiboImpulse(string sName)
{
   int nType = -2;
   int i, nObjType, nFiboLevels;
   bool bIsCorrect, bIsImpuls;
   double nValue;
   
   PrintD("IsFiboImpulse START: sName = " + sName);// .

   //  ,     100%,    ,  
   //      100 - 
   nObjType = ObjectType(sName);
   if (nObjType == OBJ_FIBO)
   {
      bIsCorrect = false;
      bIsImpuls = false;
      nFiboLevels = ObjectGet( sName, OBJPROP_FIBOLEVELS );
      for(i=0; i < nFiboLevels; i++)
      {
         nValue = ObjectGet(sName, OBJPROP_FIRSTLEVEL + i);
         
         if ( nValue > 1)
            bIsImpuls = true;     
         else if ( (nValue < 1) && (nValue > 0) )
            bIsCorrect = true;     
      }

      if (bIsImpuls)
      {
         if (bIsCorrect)
            nType = 0;
         else
            nType = 1;
      }
      else
      {
         if (bIsCorrect)
            nType = -1;
      }
   }
   
   return (nType);
}
//+-------------------------------------------------------------------------------------------------------------------------+
//   .
void MakeFiboImpulse(string sName)
{
   int i, nFiboLevels, nSize; 
   double nValue;
   double arFiboLevelsValues[];
   string sLevelDescription, sWaveName, sLevelDescTemplate;
 
   PrintD("MakeFiboImpulse START: sName = " + sName);//  .
   nSize = ArraySize(FIBO_LEVELS);//    .
   ArrayResize(arFiboLevelsValues, nSize);//   .
   nFiboLevels = 0;//    .

   for(i = 0; i < nSize; i++)//     .
   {
      nValue = FIBO_LEVELS[i];//      .
      if ((nValue >= 1) || (nValue == 0))//    , ..  0, 100%     100% 
      {
         arFiboLevelsValues[nFiboLevels] = nValue;//       .
         nFiboLevels++;//    .
      }
   }
   ObjectSet(sName, OBJPROP_FIBOLEVELS, nFiboLevels );//   .
   sLevelDescTemplate = "";//  .  .

   if (GlobalVariableGet("ShowFiboPrice") == 1)//    "    ",
      sLevelDescTemplate = " (%$)";//       .
   
   if (GlobalVariableGet("ShowFiboWaveName") == 1)//    "     ",
   {
      sWaveName = GetWaveName(sName);//       , 
      if (sWaveName != "")//   ,
         sLevelDescTemplate = sLevelDescTemplate + " " + sWaveName;//       .
   }

   if (GlobalVariableGet("ShowFiboTF") == 1)//    "     ",
      sLevelDescTemplate = sLevelDescTemplate + " " + GetTFNameByColor(ObjectGet(sName, OBJPROP_COLOR));//        .

   for(i=0; i < nFiboLevels; i++)//   .
   {
      ObjectSet(sName, OBJPROP_FIRSTLEVEL + i, arFiboLevelsValues[i]);//  .
      sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1) + sLevelDescTemplate;//  .
      ObjectSetFiboDescription(sName, i, sLevelDescription);//  .
   }
   PrintD("MakeFiboImpulse END:");// .
   return;
}
//+----------------------------------------------------------------------------------------------------------------------+
//   .
void MakeFiboCorrection(string sName)
{
   int i, nFiboLevels; 
   double nValue;
   double arFiboLevelsValues[];
   string sLevelDescription, sWaveName, sLevelDescTemplate;
   int nSize;

   PrintD("MakeFiboCorrection START: sName = " + sName);
   nSize = ArraySize(FIBO_LEVELS);//    .
   ArrayResize(arFiboLevelsValues, nSize);//    .
   nFiboLevels = 0;//     .
   for(i = 0; i < nSize; i++)//    .
   {
      nValue = FIBO_LEVELS[i];//     .
      if (nValue <= 1)//    , ..     100%
      {
         arFiboLevelsValues[nFiboLevels] = nValue;//       .
         nFiboLevels++;//    .
      }
   }
   ObjectSet(sName, OBJPROP_FIBOLEVELS, nFiboLevels );//   .
   sLevelDescTemplate = "";//  .  .

   if (GlobalVariableGet("ShowFiboPrice") == 1)//    "    ",
      sLevelDescTemplate = " (%$)";//       .
   
   if (GlobalVariableGet("ShowFiboWaveName") == 1)//    "     ",
   {
      sWaveName = GetWaveName(sName);//       , 
      if (sWaveName != "")//   ,
         sLevelDescTemplate = sLevelDescTemplate + " " + sWaveName;//       .
   }

   if (GlobalVariableGet("ShowFiboTF") == 1)//    "     ",
      sLevelDescTemplate = sLevelDescTemplate + " " + GetTFNameByColor(ObjectGet(sName, OBJPROP_COLOR));//        .
   
   for(i=0; i < nFiboLevels ; i++)// .
   {
      ObjectSet(sName, OBJPROP_FIRSTLEVEL + i, arFiboLevelsValues[i]);//  .
   
      if (GlobalVariableGet("ShowFiboDoubleName") == 0)//     "     ",
         sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1);//   .
      else//    "     ",
         sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1) + " .. " + DoubleToStr((1 - arFiboLevelsValues[i])*100, 1);//   .
   
      ObjectSetFiboDescription(sName, i, sLevelDescription + sLevelDescTemplate);//  .
   }
   PrintD("MakeFiboCorrection END:");
   return;
}
//+-----------------------------------------------------------------------------------------------------------------------------------+
//   ,        100%.
void MakeFiboNormal(string sName)
{
   int i, nFiboLevels; 
   string sLevelDescription, sWaveName, sLevelDescTemplate;
   
   PrintD("MakeFiboNormal START: sName = " + sName);//  .
   if(IsFiboImpulse(sName) == FIBO_NORMAL)
   {
      PrintD("MakeFiboNorma END1:");
      return;
   }   
   nFiboLevels = ArraySize(FIBO_LEVELS);//    .
   ObjectSet(sName, OBJPROP_FIBOLEVELS, nFiboLevels );//  .
   sLevelDescTemplate = "";//   .

   if (GlobalVariableGet("ShowFiboPrice") == 1)//    "    ",
      sLevelDescTemplate = " (%$)";//       .
   
   if (GlobalVariableGet("ShowFiboWaveName") == 1)//    "     ",
   {
      sWaveName = GetWaveName(sName);//       , 
      if (sWaveName != "")//   ,
         sLevelDescTemplate = sLevelDescTemplate + " " + sWaveName;//       .
   }

   if (GlobalVariableGet("ShowFiboTF") == 1)//    "     ",
      sLevelDescTemplate = sLevelDescTemplate + " " + GetTFNameByColor(ObjectGet(sName, OBJPROP_COLOR));//        .

   for(i=0; i < nFiboLevels ; i++)// .
   {
      ObjectSet(sName, OBJPROP_FIRSTLEVEL + i, FIBO_LEVELS[i]);//  .
   
      if (GlobalVariableGet("ShowFiboDoubleName") == 0)//     "     ",
         sLevelDescription = DoubleToStr(FIBO_LEVELS[i]*100, 1);//   .
      else//    "     ",
      {
         if((FIBO_LEVELS[i] >= 0)&&(FIBO_LEVELS[i] <= 1))//    0%   100% 
            sLevelDescription = DoubleToStr(FIBO_LEVELS[i]*100, 1) + " .. " + DoubleToStr((1 - FIBO_LEVELS[i])*100, 1);//   ,
         else//    100%
            sLevelDescription = DoubleToStr(FIBO_LEVELS[i]*100, 1);//   .
      }
      ObjectSetFiboDescription(sName, i, sLevelDescription + sLevelDescTemplate);//  .
   }
   PrintD("MakeFiboNormal END2:");//  .
   return;
}
//+-----------------------------------------------------------------------------------------------------------------------------------+
//         (, , , )
void ObjectPropertiesForm(string name)
{
   int ObjType, nObjTF, FiboType;
   double dTLBottom, dPivotPrice;
   datetime dtTLStart;
   string sNum, sWaveName, sFirstWave, sPivotName, sTFName;
   string asProperties[11]={"", "", "", "", "", "", "", "", "", "", ""};
   color clObjColor;
   
   PrintD("ObjectPropertiesForm START: sName = " + name);// .
   sNum = Object_Number(name);//  
   ObjType = ObjectType(name);//  .
   asProperties[10] = ObjType;
   if(GetVATSMFObjectName(name, FZR) != "")// ,
      asProperties[10] = OBJ_RECTANGLE;//       .
   if(GetVATSMFObjectName(name, WAVE_LINE) != "" || GetVATSMFObjectName(name, WAVE_NAME) != "")//     ,
   {
      asProperties[0] = GlobalVariableGet("AddTFToName");//   "     "    .
      
      sWaveName = "";//   .
      if(ObjectFind(WAVE_NAME + " "+ sNum) != -1)//           ,
         asProperties[1] = Object_Name(ObjectDescription(WAVE_NAME + " "+ sNum));//     .
      else//    ,   
      {//      ,       . 
         sFirstWave = FindSameTFWave(name, -1);
         if(sFirstWave != "")//   ,
         {
            sWaveName = GetWaveName(sFirstWave);//      .
            if(FindElderTFWave(name, -1) == "")//       ,
            {//     .
               if(sWaveName == "A")
                  asProperties[1] = "B";
               if(sWaveName == "B")
                  asProperties[1] = "C";
               if(sWaveName == "C")
                  asProperties[1] = "4";
               if(sWaveName == "4")
                  asProperties[1] = "5";
               if(sWaveName == "5")
                  asProperties[1] = "A";
               if(sWaveName == "a(C)")
                  asProperties[1] = "b(C)";
               if(sWaveName == "b(C)")
                  asProperties[1] = "c(C)";
               if(sWaveName == "c(C)")
                  asProperties[1] = "4(C)";
               if(sWaveName == "4(C)")
                  asProperties[1] = "5(C)";
               if(sWaveName == "5(C)")
                  asProperties[1] = "4";
            }
            else//      ,
               asProperties[1] = "A";//     "".
         }
         else//           ,
            asProperties[1] = "A";//     "".
      }
      
      //     ,
      if(GlobalVariableGet("FontSize") == 0 || GlobalVariableGet("FontSize") < 6)//  ,
         GlobalVariableSet("FontSize", 10);//    . 
      //       
      asProperties[2] = GlobalVariableGet("FontSize");//    .
   }
   
   if(GetVATSMFObjectName(name, WAVE_LINE) != ""
    ||GetVATSMFObjectName(name, FIBO_SCALE) != "")//    ,
   {
      if(GlobalVariableGet("TLWidth") == 0)
         GlobalVariableSet("TLWidth", 2);

      if(ObjectType(name) == OBJ_TREND)//     .
      {
         if(ObjectGet(name, OBJPROP_STYLE) == STYLE_SOLID && ObjectGet(name, OBJPROP_WIDTH) == 1)//   1.
            asProperties[3] = 1;//       .
         else if(ObjectGet(name, OBJPROP_WIDTH) > 1)//   1, 
            asProperties[3] = 2;//        .
         else if(ObjectGet(name, OBJPROP_STYLE) == STYLE_DASH)//   
            asProperties[3] = 3;//      .

         asProperties[4] = 0;//      .
      }
      
      if(ObjectFind(FIBO_SCALE + " " + sNum) != -1)//        ,
         switch(IsFiboImpulse(FIBO_SCALE + " " + sNum))//   .
         {
         case 1:
            asProperties[4] = 1;// .
            break;
         case -1:
            asProperties[4] = 2;// .
            break;
         case 0:
            asProperties[4] = 3;// .
         }

      asProperties[5] = GlobalVariableGet("NarrowFibo");//      " ".
      asProperties[6] = GlobalVariableGet("ShowFiboPrice");//      "   ".
      asProperties[7] = GlobalVariableGet("ShowFiboWaveName");//      "  ".
      asProperties[8] = GlobalVariableGet("ShowFiboTF");//      "  ".
   }
  
   if(GetVATSMFObjectName(name, NK) != "")
   {
      if(ObjectGet(name, OBJPROP_STYLE) == STYLE_DOT)
         asProperties[3] = 4;// .
      if(ObjectGet(name, OBJPROP_STYLE) == STYLE_DASHDOT)
         asProperties[3] = 5;// .
      asProperties[10] = 3;//    .
   }

   asProperties[9] = GetTFNameByColor(ObjectGet(name, OBJPROP_COLOR));//      .
   Link(asProperties);//          .
   
   if(StrToDouble(asProperties[0]) > 1)//     "",
      return;//   .
   

   clObjColor = GetColorByTFName(asProperties[9]);// .
   nObjTF = GetTFByColor(clObjColor);
   ObjectSet(name, OBJPROP_COLOR, clObjColor);//   .
   if(ObjType == OBJ_FIBO)//   ,
      ObjectSet(name, OBJPROP_LEVELCOLOR, clObjColor);//   .

   //      .
   if(GetVATSMFObjectName(name, WAVE_LINE) != "" || GetVATSMFObjectName(name, WAVE_NAME) != "")
   {
      GlobalVariableSet("AddTFToName", StrToDouble(asProperties[0]));//   "   "
      GlobalVariableSet("FontSize", StrToDouble(asProperties[2]));//  .

      if(asProperties[0] == "1")
         sTFName =" " + asProperties[9];
      else
         sTFName = "";
     
      sWaveName = asProperties[1] + sTFName;// .
      CreateWaveName(name, sWaveName, nObjTF);//  .
      if(asProperties[1] == "B" || asProperties[1] == "b(C)" || asProperties[1] == "4" || asProperties[1] == "4(C)") //    "B"  "b(C)",
         CreateNK(name);//  .
   }
   
   if(GetVATSMFObjectName(name, WAVE_LINE) != "")//  ,
   {
      switch(StrToInteger(asProperties[3]))//      .
      {
      case 1://.
         ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet(name, OBJPROP_WIDTH, 1);
         break;
      case 2://.
         ObjectSet(name, OBJPROP_WIDTH, GlobalVariableGet("TLWidth"));
         break;
      case 3://.
         ObjectSet(name, OBJPROP_WIDTH, 1);
         ObjectSet(name, OBJPROP_STYLE, STYLE_DASH);
         break;
      }
      
      sPivotName = PIVOT + " " + Object_Number(name);//  .
      if(ObjectFind(sPivotName) != -1)//     ,
         SetObjectColor(sPivotName, clObjColor);//   .
      else//  .
      {
         dTLBottom = Price_(name, 1);//  .
         dtTLStart = Time_(name, 1);//  .
         dPivotPrice = dTLBottom + Object_Direction(name)*0.0001;//   .
PrintD(dPivotPrice + " " + dtTLStart + " " + sPivotName);               
         ObjectCreate(sPivotName, OBJ_ARROW, 0, dtTLStart, dPivotPrice);// .
         SetObjectColor(sPivotName, clObjColor);// .
         AdjustPivot(sPivotName);//       .
      }
      
      AdjustTrendLine(name);//    .               

      if(ObjectFind(FZR + " " + Object_Number(name)) != -1)//     ,
         SetObjectColor(FZR + " " + Object_Number(name), clObjColor);//   .
   }
   
   if(GetVATSMFObjectName(name, NK) != "")
   {
      if(asProperties[3] == "4")
         ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
      else
         ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOT);
   }
   
   //     .
   if(GetVATSMFObjectName(name, WAVE_LINE) != ""||GetVATSMFObjectName(name, FIBO_SCALE) != "")
   {
      GlobalVariableSet("NarrowFibo", StrToDouble(asProperties[5]));// .
      GlobalVariableSet("ShowFiboPrice", StrToDouble(asProperties[6]));//  .
      GlobalVariableSet("ShowFiboWaveName", StrToDouble(asProperties[7]));// .
      GlobalVariableSet("ShowFiboTF", StrToDouble(asProperties[8]));// .

      FiboType = StrToDouble(asProperties[4]);//  
         
      if(FiboType != 0)//    " ",
      {
         name=CreateFibo(name, nObjTF);//  .
                     
         switch(FiboType)
         {
            case 1:
               MakeFiboImpulse(name);// .
               break;         
            case 2:
               MakeFiboCorrection(name);//.
               break;         
            case 3:
               MakeFiboNormal(name);//.
               break;         
         }               
      }
   }
}
//+---------------------------------------------------------------------------------------------+
//  4      AutoIt3
void Link(string &asProperties[])
{
   int i, hFile, hWndChart;
   string sAllTFName, sAllTFColor, sWaveNames, sFiboLevel, nAddTFToName;
   string sFormType, sFormName, sWave, nFontSize, nWaveLineType, nFiboType, nNarrowFibo, nShowPrice, nShowWaveName, nShowWaveTF, sWaveTF;

   PrintD("Link START:");// .
   sFormType = asProperties[10];//  .

   sAllTFName = "";//    .
   sAllTFColor = "";//    .
   hWndChart = WindowHandle(Symbol(), 0);//  .
   hFile = FileOpen("link.csv", FILE_CSV|FILE_WRITE,";");//    

   for(i=0; i < ArraySize(ALL_TF_NAME); i++)//       ,        . 
   {
      sAllTFName = sAllTFName + ALL_TF_NAME[i] + ";";
      sAllTFColor = sAllTFColor + ALL_TF_COLOR[i] + ";";
   }
   sAllTFName = StringSubstr(sAllTFName,0, StringLen(sAllTFName)-1);
   sAllTFColor = StringSubstr(sAllTFColor,0, StringLen(sAllTFColor)-1);
   
   sWaveNames = "";//    .
   for(i=0; i < ArraySize(WAVE_NAMES); i++)
      sWaveNames = sWaveNames + WAVE_NAMES[i] + ",";//       .
   sWaveNames = StringSubstr(sWaveNames,0, StringLen(sWaveNames)-1);

   if(sFormType != "4" && sFormType != "1" && sFormType != "5")//      .
   {   
      nAddTFToName = asProperties[0];
      sWave = asProperties[1];
      nFontSize = StrToInteger(asProperties[2]);
      nWaveLineType = asProperties[3];
      nFiboType = asProperties[4];
      nNarrowFibo = StrToInteger(asProperties[5]);
      nShowPrice = StrToInteger(asProperties[6]);
      nShowWaveName = StrToInteger(asProperties[7]);
      nShowWaveTF = StrToInteger(asProperties[8]);
      sWaveTF = asProperties[9];
      sFiboLevel = nNarrowFibo + " " + nShowPrice + " " + nShowWaveName + " " + nShowWaveTF;
      FileWrite(hFile, GetAncestor(hWndChart,2), sFormType, nAddTFToName, sWave, nFontSize, nWaveLineType, nFiboType, sFiboLevel, sWaveTF + "\n" + sAllTFName + "\n" + sAllTFColor + "\n" + sWaveNames + "\n");
      sFormName = " ";
   }
   
   if(sFormType == "4" )//     .
   {
      FileWrite(hFile, GetAncestor(hWndChart,2), sFormType, asProperties[0], asProperties[1], asProperties[2], asProperties[3], asProperties[4], asProperties[5], asProperties[6], asProperties[7], asProperties[8], asProperties[9] + "\n" + sAllTFName + "\n" + sAllTFColor + "\n" + sWaveNames + "\n");
      sFormName = " ";

   }
   if(sFormType == "1")//    .
   {
      FileWrite(hFile, GetAncestor(hWndChart,2), sFormType + "\n" + sAllTFName + "\n" + sAllTFColor + "\n" + sWaveNames + "\n");      
      sFormName = "";
   }
   
   if(sFormType == "5")//     .
   {
      FileWrite(hFile, GetAncestor(hWndChart,2), sFormType, StrToInteger(asProperties[0]), StrToInteger(asProperties[1]), StrToInteger(asProperties[2]), StrToInteger(asProperties[3]), StrToInteger(asProperties[4]), StrToInteger(asProperties[5]), StrToInteger(asProperties[6]), StrToInteger(asProperties[7]), StrToInteger(asProperties[8]), StrToInteger(asProperties[9]), StrToInteger(asProperties[11]), asProperties[12], asProperties[13], asProperties[14], asProperties[15], StrToInteger(asProperties[16]) + "\n" + sAllTFName + "\n" + sAllTFColor + "\n" + sWaveNames + "\n");
      sFormName = "  ";
   }

   FileClose(hFile);

   uchar path[];
   StringToCharArray(TerminalPath() + "\MQL4\Files\Form.exe",path);
   WinExec(path,0);

   uchar uchClass[];
   StringToCharArray("AutoIt v3 GUI",uchClass);
   uchar uchTitle[];
   StringToCharArray(sFormName,uchTitle);
   while(true)
   {
      Sleep(200);
      if(FindWindowA(uchClass, uchTitle) != 0)
         continue;
      break;
   }
   if(sFormType != "1")
   {
      hFile = FileOpen("link.csv", FILE_CSV|FILE_READ,";");
      for(i = 0; i < ArraySize(asProperties); i++)
         asProperties[i] = FileReadString(hFile);
      FileClose(hFile);
   }   
}  
//+---------------------------------------------------------------------------------------------+
//    
string CreateFibo(string sName, int nPeriod)
{
   string sFiboName, sFDescr, sTLName;
   double dFPrice1, dFPrice2;
   datetime dtFTime1, dtFTime2;
   color clFibo;
      
   PrintD("CreateFibo START: sName = " + sName + ", nPeriod = " + nPeriod);//  .
   if(ObjectType(sName) == OBJ_FIBO)//     ,
   {
      ObjectSet(sName, OBJPROP_COLOR, GetColorByTF(nPeriod));//    .
      PrintD("CreateFibo END1: sName = " + sName);//  .
      return(sName);//   .
   }
   sFiboName = "FiboScale " + Object_Number(sName);// .
   clFibo = GetColorByTF(nPeriod);// 
   dtFTime1 = ObjectGet(sName, OBJPROP_TIME2);//     .
   dFPrice1 = ObjectGet(sName, OBJPROP_PRICE2);
   dtFTime2 = ObjectGet(sName, OBJPROP_TIME1);//     .
   dFPrice2 = ObjectGet(sName, OBJPROP_PRICE1);

   if(GlobalVariableGet("NarrowFibo") == 0)//      " ", 
   {
      dtFTime1 = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFTime1, true)-10));//     10       
      dtFTime2 = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFTime2, true)+10));//    10      .
   }
   else//     " ",
   {
      dtFTime1 = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFTime1, true)+5));//    5     ,
      dtFTime2 = dtFTime1;//       .
   }

   if(ObjectFind(sFiboName) == -1)//  ,
   {   
      ObjectCreate(sFiboName, OBJ_FIBO, 0, dtFTime1, dFPrice1, dtFTime2, dFPrice2);//  .
      ObjectSet(sFiboName, OBJPROP_LEVELSTYLE, STYLE_DOT);//  .
      ObjectSet(sFiboName, OBJPROP_LEVELWIDTH, 1);//  1.
      ObjectSet(sFiboName, OBJPROP_STYLE, STYLE_DOT);//  .
      ObjectSet(sFiboName, OBJPROP_WIDTH, 1);//  1.
      ObjectSet(sFiboName, OBJPROP_BACK, true);//   .
      ObjectSet(sFiboName, OBJPROP_RAY, false);//    .
      ObjectSet(sFiboName, OBJPROP_TIMEFRAMES, ObjectGet(sName, OBJPROP_TIMEFRAMES));//  .
   }
   else//  ,
   {
      ObjectSet(sFiboName, OBJPROP_PRICE1, dFPrice1);//   
      ObjectSet(sFiboName, OBJPROP_TIME1, dtFTime1);
      ObjectSet(sFiboName, OBJPROP_PRICE2, dFPrice2);// .
      ObjectSet(sFiboName, OBJPROP_TIME2, dtFTime2);
   }
   SetObjectColor(sFiboName, GetColorByTF(nPeriod));//     .
   PrintD("CreateFibo START: sFiboName = " + sFiboName);//  .
   return(sFiboName);
}
//+------------------------------------------------------------------------------------------------------+
//     .
void CreateWaveName(string name, string WaveName, int nPeriod)
{
   int nWindow;
   string sTextName;
   double dTLTop, dTLBottom, dTemp, dTextPrice;
   datetime dtTLStart, dtTLEnd, dtTemp, dtTextTime;
   color clText;

   PrintD("CreateWaveName START: name = " + name + ", WaveName = " + WaveName + ", nPeriod = " + nPeriod);// .
   nWindow = ObjectFind(name);
   sTextName = WAVE_NAME + " " + Object_Number(name);
   clText = GetColorByTF(nPeriod);
   dtTLStart = ObjectGet(name, OBJPROP_TIME1);
   dtTLEnd = ObjectGet(name, OBJPROP_TIME2);
   dTLBottom = ObjectGet(name, OBJPROP_PRICE1);
   dTLTop = ObjectGet(name, OBJPROP_PRICE2);

   if ( ((dtTLEnd < dtTLStart) && (dTLTop < dTLBottom)) || ((dtTLEnd < dtTLStart) && (dTLTop > dTLBottom)) )
   {
      dtTemp = dtTLStart;
      dtTLStart = dtTLEnd;
      dtTLEnd = dtTemp;
      dTemp = dTLBottom;
      dTLBottom = dTLTop;
      dTLTop = dTemp;
   }

   dTextPrice = dTLTop + 0.1*(dTLTop - dTLBottom);
   dtTextTime = dtTLEnd - 0.05*(dtTLEnd - dtTLStart);

   ObjectCreate(sTextName, OBJ_TEXT, nWindow, dtTextTime, dTextPrice);
   ObjectSet(sTextName, OBJPROP_COLOR, clText);
   ObjectSetText(sTextName, WaveName, GlobalVariableGet("FontSize"), FontFace(), clText);    
   ObjectSet(sTextName, OBJPROP_BACK, false);
   SetObjectVisibleOnTF(sTextName);

   return;
}
//+--------------------------------------------------------------------------------------+
//      ,   "" .
bool CloseScriptOnPressedHotKey()
{
   int hwnd;

   PrintD("CloseScriptOnPressedHotKey START:");// .
   hwnd = WindowHandle(Symbol(), 0);
   if(
      (GetAsyncKeyState(VK_1) != 0)||
      (GetAsyncKeyState(VK_2) != 0)||
      (GetAsyncKeyState(VK_3) != 0)||
      (GetAsyncKeyState(VK_4) != 0)||
      (GetAsyncKeyState(VK_5) != 0)||
      (GetAsyncKeyState(VK_6) != 0)||
      (GetAsyncKeyState(VK_7) != 0)||
      (GetAsyncKeyState(VK_W) != 0)||
      (GetAsyncKeyState(VK_SPACE) != 0)||
      (GetAsyncKeyState(VK_Q) != 0)||
      (GetAsyncKeyState(VK_A) != 0)||
      (GetAsyncKeyState(VK_S) != 0)||
      (GetAsyncKeyState(VK_Z) != 0)          
      )
   {
      ResetHotKeyState();      
      PostMessageA(GetLastActivePopup(GetAncestor(hwnd,2)), WM_KEYDOWN, VK_ENTER, 0);
      PostMessageA(hwnd, WM_COMMAND, 33234, 0);

      return(true); 
   }
   else
   {
      ResetHotKeyState();
      return(false); 
   }
}
//+--------------------------------------------------------------------------------------+
//   "" .
void ResetHotKeyState()
{
   PrintD("ResetHotKeyState START:");// .

   GetAsyncKeyState(VK_1);
   GetAsyncKeyState(VK_2);
   GetAsyncKeyState(VK_3);
   GetAsyncKeyState(VK_4);
   GetAsyncKeyState(VK_5);
   GetAsyncKeyState(VK_6);
   GetAsyncKeyState(VK_7);
   GetAsyncKeyState(VK_SPACE);
   GetAsyncKeyState(VK_Q);
   GetAsyncKeyState(VK_W);
   GetAsyncKeyState(VK_A);
   GetAsyncKeyState(VK_S);
   GetAsyncKeyState(VK_Z);
   GetAsyncKeyState(VK_OEM_3);
   return;
} 
//+--------------------------------------------------------------------------------------+
//        .
void DeleteObjectsForm()
{
   int i, N, nTF;
   string sName,  sDeleteWaveLines, sDeleteWaveNames, sDeleteBrokenNKs, sDeleteNormalNKs, sDeleteFiboScales, sDeletePivots, sDeleteTargets, sDeleteAllObjects, sDeleteTrades;
   string asProperties[11]={"", "", "", "", "", "", "", "", "", "", ""};

   PrintD("DeleteObjectsForm START:");// .
   asProperties[10] = "4";//  " ".
   Link(asProperties);//          .
   
   sDeleteTrades = asProperties[0];//       .
   sDeleteAllObjects = asProperties[1];//           .
   sDeleteWaveLines = asProperties[2];//     .
   sDeleteWaveNames = asProperties[3];//      .
   sDeleteBrokenNKs = asProperties[4];//      .
   sDeleteNormalNKs = asProperties[5];//      .
   sDeleteFiboScales = asProperties[6];//     .
   sDeletePivots = asProperties[7];//     .
   sDeleteTargets = asProperties[8];//     .
   nTF = GetTFByColor(GetColorByTFName(asProperties[9]));//    ,  ,   . 

   N = ObjectsTotal();//  .
   for(i=(N-1); i >=0; i--)
   {
      if(sDeleteTrades == "1")//   "   ",
      {
         sName = ObjectName(i);
         if ( (StringGetChar(sName, 0) == '#')
           && (ObjectType(sName) == OBJ_TREND || ObjectType(sName) == OBJ_ARROW) )//      .
            ObjectDelete(sName);//  
         continue;//  .
      }
      if(sDeleteAllObjects == "1")//E   "  ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), ALL);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteWaveLines == "1")//E   " ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), WAVE_LINE);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteWaveNames == "1")//E   "  ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), WAVE_NAME);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteBrokenNKs == "1")//E   "  ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), NK);//        .
         if(sName == "" || ObjectGet(sName, OBJPROP_STYLE) != STYLE_DASHDOT)// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteNormalNKs == "1")//E   "  ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), NK);//        .
         if(sName == "" || ObjectGet(sName, OBJPROP_STYLE) != STYLE_DOT)// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteFiboScales == "1")//E   " ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), FIBO_SCALE);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeletePivots == "1")//E   " ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), PIVOT);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
      if(sDeleteTargets == "1")//E   " ",
      {
         sName = GetVATSMFObjectName(ObjectName(i), TARGET);//        .
         if(sName == "")// ,
            continue;//    .
         if(GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < nTF)//      .
            ObjectDelete(sName);// .
         continue;//   .
      }
   }
}
//+--------------------------------------------------------------------------------------+
//       .
void ChangeSetingsForm()
{
   string asProperties[17]={"","","","","","","","","","","","","","","","",""};
   
   PrintD("ChangeSetingsForm START:");// .
   asProperties[0] = GlobalVariableGet("AddTFToName");//   "     "    .
   
   //     ,
   if(GlobalVariableGet("FontSize") == 0 || GlobalVariableGet("FontSize") < 6)//  ,
      GlobalVariableSet("FontSize", 10);//    . 
   //       
   asProperties[1] = GlobalVariableGet("FontSize");//    .
   asProperties[2] = GlobalVariableGet("FontFace");//   .   

   //     ,
   if(GlobalVariableGet("TLWidth") == 0)
      GlobalVariableSet("TLWidth", 2);//    .
   asProperties[3] = GlobalVariableGet("TLWidth");//   .
   
   asProperties[4] = GlobalVariableGet("NarrowFibo");//   "   ".
   asProperties[5] = GlobalVariableGet("ShowFiboPrice");//      "    ".
   asProperties[6] = GlobalVariableGet("ShowFiboWaveName");//      "     ".
   asProperties[7] = GlobalVariableGet("ShowFiboTF");//      "     ".
   asProperties[8] = GlobalVariableGet("ShowFiboDoubleName");//      "     ".
   
   if(GlobalVariableGet("NumFLevelsLeave") == 0)
      GlobalVariableSet("NumFLevelsLeave", 1);
   asProperties[9] = GlobalVariableGet("NumFLevelsLeave");//      "   ".
   asProperties[10] = 5;//   .
   asProperties[16] = GlobalVariableGet("AutoPivot");//      "  .".
   asProperties[11] = GlobalVariableGet("PRINT_DEBUG");//      ""  "".

   Link(asProperties);//    .

   if(StrToDouble(asProperties[0]) > 1)//     "",
      return;//   .
   
   GlobalVariableSet("AddTFToName", StrToDouble(asProperties[0]));//    
   GlobalVariableSet("FontSize", StrToDouble(asProperties[1]));
   GlobalVariableSet("FontFace", StrToDouble(asProperties[2]));
  
   if(asProperties[12] != "0")//    .
   {
      AddTFToNames(StrToInteger(asProperties[12]));//    .
      ResizeWavesNames(StrToInteger(asProperties[12]));//      .
   }
      
   GlobalVariableSet("TLWidth", StrToDouble(asProperties[3]));
   if(asProperties[13] != "0")
      ChangeTLineWidth(StrToInteger(asProperties[13]));         
   
   GlobalVariableSet("NarrowFibo", StrToDouble(asProperties[4]));
   if(asProperties[14] != "0")
      ChangeFiboWidth(StrToInteger(asProperties[14]));

   GlobalVariableSet("ShowFiboPrice", StrToDouble(asProperties[5]));
   GlobalVariableSet("ShowFiboWaveName", StrToDouble(asProperties[6]));
   GlobalVariableSet("ShowFiboTF", StrToDouble(asProperties[7]));
   GlobalVariableSet("ShowFiboDoubleName", StrToDouble(asProperties[8]));
   GlobalVariableSet("NumFLevelsLeave", StrToDouble(asProperties[9]));
   if(asProperties[15] != "0")
      ChangeFiboDescription(StrToInteger(asProperties[15]));

   GlobalVariableSet("AutoPivot", StrToDouble(asProperties[16]));
   GlobalVariableSet("PRINT_DEBUG", StrToDouble(asProperties[11]));
}
//+--------------------------------------------------------------------------------------+
//      .
void AddTFToNames(int nTF)
{
   int i, n, nSpaceIndex;
   string sName, sWaveName, sTFName;
   color clColor;
   
   PrintD("AddTFToNames START: nTF = " + nTF);// .
   n = ObjectsTotal();
   if(GlobalVariableGet("AddTFToName") == 1)
   {
      for(i = 0; i < n; i++)
      {
         sName = GetVATSMFObjectName(ObjectName(i), WAVE_NAME);
         if(sName == "")
            continue;
         if(!GetObjectRealTF(sName, nTF))
            continue;

         clColor = ObjectGet(sName, OBJPROP_COLOR);
         sTFName = GetTFNameByColor(clColor);
         sWaveName = ObjectDescription(sName);
         nSpaceIndex = StringFind(sWaveName, " ", 1);

         if (nSpaceIndex == -1)
            ObjectSetText(sName, sWaveName + " " + sTFName);
         else
            ObjectSetText(sName, sWaveName); 
      }
   }
   else
   {
      for(i = 0; i < n; i++)
      {
         sName = GetVATSMFObjectName(ObjectName(i), WAVE_NAME);
         if(sName == "")
            continue;
         if(!GetObjectRealTF(sName, nTF))
            continue;

         sWaveName = ObjectDescription(sName);
         nSpaceIndex = StringFind(sWaveName, " ", 1);
         if (nSpaceIndex == -1)
            continue;
         else
            sWaveName = StringSubstr(sWaveName, 0, nSpaceIndex);
         ObjectSetText(sName, sWaveName); 
      }
   }
   return;
}
//+--------------------------------------------------------------------------------------+
//    .
void ResizeWavesNames(int nTF)
{
   int i, nFontSize;
   string sName, sWaveName;
   
   PrintD("ResizeWavesNames START: nTF = " + nTF);// .
   nFontSize = GlobalVariableGet("FontSize");
   for(i = 0; i < ObjectsTotal(); i++)
   {
      sName = GetVATSMFObjectName(ObjectName(i), WAVE_NAME);

      if(sName == "")
         continue;
         
      if(nTF == 0)
         continue;
         
      if(GetObjectRealTF(sName, nTF))
      {
         sWaveName = ObjectDescription(sName);
         ObjectSetText(sName, sWaveName, nFontSize, FontFace());
      }
   }
      
   return;
}
//+--------------------------------------------------------------------------------------+
//    .
string FontFace()
{
   int nFontFace;
   string sFontFace;
      
   PrintD("FontFace START:");// .
   nFontFace = GlobalVariableGet("FontFace");
   switch (nFontFace)
   {
   case 0:
      sFontFace = "Arial";
      break;
   case 1:
      sFontFace = "Arial Black";
      break;
   case 2:
      sFontFace = "Arial Narrow";
      break;
   case 3:
      sFontFace = "Times New Roman";
      break;
   case 4:
      sFontFace = "Monotype Corsiva";
      break;
   default:
      sFontFace = "Arial";
      break;
   }
   
   return(sFontFace);
}
//+--------------------------------------------------------------------------------------+
//    .
void ChangeTLineWidth(int nTF)
{
   int i;
   string sName;
   
   PrintD("ChangeTLineWidth START: nTF = " + nTF);// .
   for(i = 0; i < ObjectsTotal(); i++)
   {
      sName = GetVATSMFObjectName(ObjectName(i), WAVE_LINE);//   .
      if(sName == "")
         continue;
         
      if(GetObjectRealTF(sName, nTF))
         ObjectSet(sName,OBJPROP_WIDTH, GlobalVariableGet("TLWidth"));
   }
   return;
}
//+--------------------------------------------------------------------------------------+
//         .
bool GetObjectRealTF(string sName, int nTF)
{
   int i, nPeriod, nRealPeriod;

   PrintD("GetObjectRealTF START: sName = " + sName + ", nTF = " + nTF);// .
   if(nTF == 0)// "0"            .
      return(false);//  false.
   if(nTF == 10)// "10"             .
      return(true);//        true.

   nPeriod = GetTFByColor(ObjectGet(sName, OBJPROP_COLOR));// .
   i=0;
   while((nPeriod >= REAL_TF[i])&&(REAL_TF[i] != 0))//     -            ,
   {
      i++;// ,
      nRealPeriod = i;//      .
   }
   if(nRealPeriod != nTF)//       ,      ,      .
      return(false);
  
   return(true);
}
//+--------------------------------------------------------------------------------------+
//   .
void ChangeFiboWidth(int nTF)
{
   int i, nObjType;
   string sFiboName, sTLName, name;
   double dFTop, dFBottom, dTemp;
   datetime dtFStart, dtFEnd, dtTemp;
      
   PrintD("ChangeFiboWidth START: nTF = " + nTF);// .
   for(i = 0; i < ObjectsTotal(); i++)
   {
      name = GetVATSMFObjectName(ObjectName(i), FIBO_SCALE);
      if(name == "")
         continue;
      if(!GetObjectRealTF(name, nTF))
          continue;
      nObjType = ObjectType(name);

      sFiboName = FIBO_SCALE + " " + Object_Number(name);
      sTLName = WAVE_LINE + " " + Object_Number(name);
      if(ObjectFind(sTLName) != -1)
         name = sTLName;

      dtFStart = ObjectGet(name, OBJPROP_TIME1);
      dtFEnd = ObjectGet(name, OBJPROP_TIME2);
      dFBottom = ObjectGet(name, OBJPROP_PRICE1);
      dFTop = ObjectGet(name, OBJPROP_PRICE2);

      if ( ((dtFEnd > dtFStart) && (dFTop > dFBottom)) || ((dtFEnd > dtFStart) && (dFTop < dFBottom)) )
      {
         dtTemp = dtFStart;
         dtFStart = dtFEnd;
         dtFEnd = dtTemp;
         dTemp = dFBottom;
         dFBottom = dFTop;
         dFTop = dTemp;
      }
      if(GlobalVariableGet("NarrowFibo") == 0)      
      {
         dtFStart = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFStart, true)-10));
         dtFEnd = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFEnd, true)+10));
      }
      else
      {
         dtFStart = iTime(Symbol(), 0, (iBarShift(Symbol(), 0, dtFStart, true)+5));
         dtFEnd = dtFStart;
      }

      ObjectSet(sFiboName, OBJPROP_PRICE1, dFBottom);
      ObjectSet(sFiboName, OBJPROP_PRICE2, dFTop);
      ObjectSet(sFiboName, OBJPROP_TIME1, dtFStart);
      ObjectSet(sFiboName, OBJPROP_TIME2, dtFEnd);
   }
   return;
}
//+--------------------------------------------------------------------------------------+
//   .
void ChangeFiboDescription(int nTF)
{
   int j, i, nObjType; 
   double arFiboLevelsValues[];
   string sLevelDescription, sWaveName, sLevelDescTemplate, name;
   int nSize;
      
   PrintD("ChangeFiboDescription START: nTF = " + nTF);// .
   for(j = 0; j < ObjectsTotal(); j++)
   {      
      name = GetVATSMFObjectName(ObjectName(j), FIBO_SCALE);
      if(name == "")
         continue;
      if(!GetObjectRealTF(name, nTF))
         continue;
      nObjType = ObjectType(name);
      nSize = ObjectGet(name, OBJPROP_FIBOLEVELS);
      ArrayResize( arFiboLevelsValues, nSize );

      for(i = 0; i < nSize; i++)
      {
         arFiboLevelsValues[i] = StrToDouble(ObjectGetFiboDescription(name, i))/100;      
      }

         sLevelDescTemplate = "";
   
         if (GlobalVariableGet("ShowFiboPrice") == 1)
            sLevelDescTemplate = " (%$)";
      
         if (GlobalVariableGet("ShowFiboWaveName") == 1)
         {
            sWaveName = GetWaveName(name);
            if (sWaveName != "")
               sLevelDescTemplate = sLevelDescTemplate + " " + sWaveName;
         }

         if (GlobalVariableGet("ShowFiboTF") == 1)
            sLevelDescTemplate = sLevelDescTemplate + " " + GetTFNameByColor(ObjectGet(name, OBJPROP_LEVELCOLOR));

         for(i=0; i < nSize ; i++)
         {
            ObjectSet(name, OBJPROP_FIRSTLEVEL + i, arFiboLevelsValues[i]);
            if (GlobalVariableGet("ShowFiboDoubleName") == 0)
               sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1);
            
            else
            {
               if((arFiboLevelsValues[i] >= 0)&&(arFiboLevelsValues[i] <= 1))
               {
                  if(IsFiboImpulse(name) == -1)
                     sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1) + " .. " + DoubleToStr((1 - arFiboLevelsValues[i])*100, 1);
                  else
                     sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1);
               }
               else
                  sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1);
            }
            ObjectSetFiboDescription(name, i, sLevelDescription + sLevelDescTemplate);
         }
   }
   return;
}
//       .
void PrintD(string sMessage)
{
   if (GlobalVariableGet("PRINT_DEBUG") == 1)
      Print(sMessage);
}
//+--------------------------------------------------------------------------------------+
//|                                                |
//+--------------------------------------------------------------------------------------+
//        .
string RenameObjectForVATSMF(string sName, color clColor)
{
   int nObjType;
   double dPrice1, dPrice2, dTemp;
   datetime dtTime1, dtTime2, dtTemp;
   string sNewName;
   
   PrintD("RenameObjectForVATSMF START: sName = " + sName);//  .
   nObjType = ObjectType(sName);//  .
   dPrice1 = ObjectGet(sName, OBJPROP_PRICE1);//  .
   dtTime1 = ObjectGet(sName, OBJPROP_TIME1);//  .
   if((nObjType == OBJ_TREND) || (nObjType == OBJ_FIBO) || (nObjType == OBJ_RECTANGLE))//  ,       
   {
      dPrice2 = ObjectGet(sName, OBJPROP_PRICE2);//   
      dtTime2 = ObjectGet(sName, OBJPROP_TIME2);//  .
   }
   if(nObjType == OBJ_TREND)//  .
   {
      if(dtTime1 > dtTime2)//      ,     .
      {
         dTemp = dPrice1;
         dPrice1 = dPrice2;
         dPrice2 = dTemp;
         dtTemp = dtTime1;
         dtTime1 = dtTime2;
         dtTime2 = dtTemp;
      }
      sNewName = "WaveLine " + TimeLocal();//   .
      ObjectCreate(sNewName, OBJ_TREND, 0, dtTime1, dPrice1, dtTime2, dPrice2);//   .
      ObjectSet(sNewName, OBJPROP_COLOR, clColor);//    .
      ObjectSet(sNewName, OBJPROP_TIMEFRAMES, ObjectGet(sName, OBJPROP_TIMEFRAMES));//     .
      ObjectSet(sNewName, OBJPROP_BACK, false);//    .
      ObjectSet(sNewName, OBJPROP_RAY, false);//    .
      ObjectSet(sNewName, OBJPROP_STYLE, STYLE_SOLID);//  .
      ObjectSet(sNewName, OBJPROP_WIDTH, GlobalVariableGet("TLWidth"));//      .
      AdjustTrendLine(sNewName);//      . 
      ObjectDelete(sName);//  .
      return(sNewName); 
   }
   if(nObjType == OBJ_ARROW)// .
   {
      sNewName = "Pivot " + TimeLocal();//  .
      ObjectCreate(sNewName, OBJ_ARROW, 0, dtTime1, dPrice1);//  .
      ObjectSet(sNewName, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);//  "  ".
      ObjectSet(sNewName, OBJPROP_COLOR, clColor);//    .
      ObjectSet(sNewName, OBJPROP_TIMEFRAMES, ObjectGet(sName, OBJPROP_TIMEFRAMES));//     .
      ObjectSet(sNewName, OBJPROP_BACK, true);//     .
      sNewName = AdjustPivot(sNewName);//      .
      ObjectDelete(sName);//  .
      return(sNewName); 
   }
   if(nObjType == OBJ_RECTANGLE)// .
   {
      sNewName = "Target " + TimeLocal();//  .
      ObjectCreate(sNewName, OBJ_RECTANGLE, 0, dtTime1, dPrice1, dtTime2, dPrice2);//  .
      ObjectSet(sNewName, OBJPROP_COLOR, clColor);//    .
      ObjectSet(sNewName, OBJPROP_TIMEFRAMES, ObjectGet(sName, OBJPROP_TIMEFRAMES));//     .
      ObjectSet(sNewName, OBJPROP_STYLE, STYLE_SOLID);//   .
      ObjectSet(sNewName, OBJPROP_WIDTH, 2);//  .
      ObjectSet(sNewName, OBJPROP_BACK, false);//    .
      ObjectDelete(sName);//  .
      return(sNewName); 
   }
   if(nObjType == OBJ_FIBO)// .
   {
      int i, nFiboLevels;
      string sLevelDescription;
      
      nFiboLevels = ArraySize(FIBO_LEVELS);//   .
      sNewName = "FiboScale " + TimeLocal();//  .
      ObjectCreate(sNewName, OBJ_FIBO, 0, dtTime1, dPrice1, dtTime2, dPrice2);//  .
      ObjectSet(sNewName, OBJPROP_COLOR, clColor);//    .
      ObjectSet(sNewName, OBJPROP_LEVELCOLOR, clColor);//     .
      ObjectSet(sNewName, OBJPROP_LEVELSTYLE, STYLE_DOT);//  .
      ObjectSet(sNewName, OBJPROP_LEVELWIDTH, 1);//  1.
      ObjectSet(sNewName, OBJPROP_STYLE, STYLE_DOT);//  .
      ObjectSet(sNewName, OBJPROP_WIDTH, 1);//  1.
      ObjectSet(sNewName, OBJPROP_BACK, true);//   .
      ObjectSet(sNewName, OBJPROP_RAY, false);//    .
      ObjectSet(sNewName, OBJPROP_TIMEFRAMES, ObjectGet(sName, OBJPROP_TIMEFRAMES));//  .
      ObjectSet(sNewName, OBJPROP_FIBOLEVELS, nFiboLevels);//  .

      for(i=0; i < nFiboLevels ; i++)// .
      {
         ObjectSet(sNewName, OBJPROP_FIRSTLEVEL + i, FIBO_LEVELS[i]);//  .

         if((FIBO_LEVELS[i] >= 0)&&(FIBO_LEVELS[i] <= 1))//   100%   0%
            sLevelDescription = DoubleToStr((1 - FIBO_LEVELS[i])*100, 1) + " .. " + DoubleToStr(FIBO_LEVELS[i]*100, 1);//   .
         else
            sLevelDescription = DoubleToStr(FIBO_LEVELS[i]*100, 1);//   100%
         ObjectSetFiboDescription(sNewName, i, sLevelDescription + " (%$)");//  .
      }
      ObjectDelete(sName);//  .
      return(sNewName); 
   }
}
//+--------------------------------------------------------------------------------------+
//      .
string AdjustPivot(string sName)
{
   int i, nShownTFs;
   double dPrice1;
   datetime dtTime1;
   color clPivot;
   string sWaveLine, sYoungerPivot, sTempName;

   PrintD("AdjustPivot START: sName = " + sName);
   clPivot = ObjectGet(sName, OBJPROP_COLOR);
   dPrice1 = Price_(sName, 1);
   dtTime1 = Time_(sName, 1);
   nShownTFs = ObjectGet(sName, OBJPROP_TIMEFRAMES);
   
   if(ObjectFind(WAVE_LINE + " " + Object_Number(sName)) != -1)//      ,
   {
      sYoungerPivot = FindYoungerTFObject(WAVE_LINE + " " + Object_Number(sName), PIVOT, 1);//   .
      if(sYoungerPivot == "")//   ,
      {
         if(GlobalVariableGet("AutoPivot") != 0)//    ,
            PlacePivot(sName);//    .
         else
         {
            PrintD("AdjustPivot END1:  " + sName + "  ,      .");// .
            ObjectDelete(sName);//  ,       .
         }
         return(sName);
      }
      else//    ,      .
      {
         ObjectSet(sName, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
         ObjectSet(sName, OBJPROP_PRICE1, Price_(sYoungerPivot, 1));//  .
         ObjectSet(sName, OBJPROP_TIME1, Time_(sYoungerPivot, 1));//  .
         ObjectSet(sName, OBJPROP_COLOR, clPivot);//    .
         ObjectSet(sName, OBJPROP_TIMEFRAMES, nShownTFs);//       .
         ObjectSet(sName, OBJPROP_BACK, true);//   .
         PrintD("AdustPivot END2:  " + sName + "    " + sYoungerPivot);// .
         return(sName);
      }
   }
   else//      ,
   {   
      sWaveLine = "";//   .
      for(i = 0; i < ObjectsTotal(); i++)// ,          .
      {
         sTempName = ObjectName(i);//  .
         if(GetVATSMFObjectName(sTempName, WAVE_LINE) == "")//   ,   .
            continue;
         if(ObjectGet(sTempName, OBJPROP_COLOR) != clPivot)//     ,   ,   .
            continue;
         if(Object_Accommodates(sTempName, sName) == "")//       ,
            continue;//  ,
         sWaveLine = sTempName;//  ,
         break;//    -    .
      }
      if(sWaveLine != "")//   ,
      {
         ObjectDelete(sName);//   .
         sName = PIVOT + " " + Object_Number(sWaveLine);//  ,    ,   ,     .
         ObjectCreate(sName, OBJ_ARROW, 0, dtTime1, dPrice1);//     .
         ObjectSet(sName, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);//  .
         ObjectSet(sName, OBJPROP_COLOR, clPivot);//    .
         ObjectSet(sName, OBJPROP_TIMEFRAMES, nShownTFs);//       .
         ObjectSet(sName, OBJPROP_BACK, true);//   .
         
         sYoungerPivot = FindYoungerTFObject(sWaveLine , PIVOT, 1);//    .
         if(sYoungerPivot == "")//   ,
         {
            PrintD("AdjustPivot END3:   " + sName + "      .   !");// .
            return(sName);
         }
         else//    ,      .
         {
            ObjectSet(sName, OBJPROP_PRICE1, Price_(sYoungerPivot, 1));//  .
            ObjectSet(sName, OBJPROP_TIME1, Time_(sYoungerPivot, 1));//  .
            PrintD("AdustPivot END4:  " + sName + "    " + sYoungerPivot);// .
            return(sName);
         }
      }
      else
      {
         return(sName);
      }
   }
}
//+--------------------------------------------------------------------------------------+
//     .
void PlacePivot(string sName)
{
   int i, nWaveDirection, nPivotBar, nWaveEndBar;
   double dPivotPrice;
   string sWaveLineName;
   datetime dtStartTime; 
   
   PrintD("PlacePivot START: sName = " + sName);
   sWaveLineName = WAVE_LINE + " " + Object_Number(sName);//      .
   dtStartTime = Time_(sWaveLineName, 1);//  .
   if(iTime(NULL, 1, iBars(0,1)-1) > dtStartTime)//      1   .
   {
      PrintD("PlacePivot END2:  " + sName + "  ,       1.");// .
      ObjectDelete(sName);//  ,       .
      return;
   }
   nPivotBar = iBarShift(NULL,1, dtStartTime) - 2;//     .
   nWaveDirection = Object_Direction(sWaveLineName);// .
   dPivotPrice = MaxMin(-nWaveDirection, 1, nPivotBar);
   nWaveEndBar = iBarShift(NULL,1,Time_(sWaveLineName, 2));//   .
   if(nPivotBar - nWaveEndBar > 60)//    60 ,
      nWaveEndBar = nPivotBar - 60;//     60     .
   
   for(i = nPivotBar; i >= nWaveEndBar; i--)//       .
   {
      if(nWaveDirection*(dPivotPrice - MaxMin(-nWaveDirection, 1, i)) > 0 )//       ,   
        dPivotPrice = MaxMin(-nWaveDirection, 1,i);//   .
   }
   ObjectSet(sName, OBJPROP_TIME1, iTime(NULL,1, nPivotBar));//    .
   ObjectSet(sName, OBJPROP_PRICE1, dPivotPrice);//           .
   ObjectSet(sName, OBJPROP_ARROWCODE, 6);
}
//+------------------------------------------------------------------+
//               .
double MaxMin(int nDirection, int nPeriod, int j)
{
   if(nDirection == 1)
      return(iHigh(NULL, nPeriod, j));
   else
      return(iLow(NULL, nPeriod, j));
}
//+--------------------------------------------------------------------------------------+
//           .
string Object_Accommodates(string sNameBig, string sNameSmall)
{
   PrintD("Object_Accommodates START: sNameBig = " + sNameBig + ", sNameSmall = " + sNameSmall);//  .
   if(ObjectType(sNameBig) != OBJ_TREND && (ObjectType(sNameSmall) != OBJ_TREND || ObjectType(sNameSmall) != OBJ_ARROW))//              ,
   {
      PrintD("Object_Accommodates END1:      ");//  .
      return("");//   .
   }
   if(ObjectType(sNameSmall) == OBJ_TREND)//     ,           . 
   {
      if(((MathAbs(Price_(sNameBig, 2) - Price_(sNameBig, 1)) - MathAbs(Price_(sNameBig, 2) - Price_(sNameSmall, 1)) - MathAbs(Price_(sNameBig, 1) - Price_(sNameSmall, 1)) >= -0.0005)//       ,
        &&(MathAbs(Price_(sNameBig, 2) - Price_(sNameBig, 1)) - MathAbs(Price_(sNameBig, 2) - Price_(sNameSmall, 2)) - MathAbs(Price_(sNameBig, 1) - Price_(sNameSmall, 2)) >= -0.0005))
        &&((MathAbs(Time_(sNameBig, 2) - Time_(sNameBig, 1)) - MathAbs(Time_(sNameBig, 2) - Time_(sNameSmall, 1)) - MathAbs(Time_(sNameBig, 1) - Time_(sNameSmall, 1)) >=  -240*GetTFByColor(ObjectGet(sNameSmall, OBJPROP_COLOR)))
        &&(MathAbs(Time_(sNameBig, 2) - Time_(sNameBig, 1)) - MathAbs(Time_(sNameBig, 2) - Time_(sNameSmall, 2)) - MathAbs(Time_(sNameBig, 1) - Time_(sNameSmall, 2)) >=  -240*GetTFByColor(ObjectGet(sNameSmall, OBJPROP_COLOR)))))
      {
         PrintD("Object_Accommodates END2: sNameSmall = " + sNameSmall);//  .
         return(sNameSmall);//     .
      }
   }
   else//   -  ,           . 
   {
      if((MathAbs(Price_(sNameBig, 2) - Price_(sNameBig, 1)) - MathAbs(Price_(sNameBig, 2) - Price_(sNameSmall, 1)) - MathAbs(Price_(sNameBig, 1) - Price_(sNameSmall, 1)) == 0)//       ,
        &&(MathAbs(Time_(sNameBig, 2) - Time_(sNameBig, 1)) - MathAbs(Time_(sNameBig, 2) - Time_(sNameSmall, 1)) - MathAbs(Time_(sNameBig, 1) - Time_(sNameSmall, 1)) == 0))
      {
         PrintD("Object_Accommodates END3: sNameSmall = " + sNameSmall);//  .
         return(sNameSmall);//     .
      }
   }
   return("");
}//+--------------------------------------------------------------------------------------+
//        (, , )  , 
//     .
string FindYoungerTFObject(string sName, string sType, int nObj)
{
   int i, j, k, n, nObjTF, nTLDirection, nSize, nMaxTF;
   string sYoungObjectName, sTLName, sYoungTLineName;
   string asYoungTLineName[];
   string asMaxTFObjectName[];
   
   PrintD("FindYoungerTFObject START: sName = " + sName + ", sType = " + sType + ", nObj = " + nObj);//  .  
   if(ObjectType(sName) != OBJ_TREND)//       ,   .
   {
      PrintD("FindYoungerTFObject END1:      !");//  .  
      return("");
   }

   nObjTF = GetTFByColor(ObjectGet(sName, OBJPROP_COLOR));//  .
   if(sType == PIVOT)//  .
   {  
      nTLDirection = Object_Direction(sName);// .
      nSize = ObjectsTotal();// .
      ArrayResize(asYoungTLineName, nSize);//      .
      ArrayResize(asMaxTFObjectName, nSize);
      j = 0;//   .
      nMaxTF = 1;//      .
      for(i = 0; i < nSize; i++)//      .
      {
         sYoungTLineName = ObjectName(i);//   ()  .
         if(GetVATSMFObjectName(sYoungTLineName, WAVE_LINE) == "")//     . 
            continue;
         if(GetTFByColor(ObjectGet(sYoungTLineName, OBJPROP_COLOR)) >= nObjTF)//     .
            continue;
         if(Object_Direction(sYoungTLineName) != nTLDirection)// ,     .
            continue;
         if(Object_Accommodates(sName, sYoungTLineName) == "")// ,       . 
            continue;

         asYoungTLineName[j] = sYoungTLineName;//          .
         if(GetTFByColor(ObjectGet(sYoungTLineName, OBJPROP_COLOR)) > nMaxTF)//     ,
            nMaxTF = GetTFByColor(ObjectGet(sYoungTLineName, OBJPROP_COLOR));//    .
         j++;//     .
      }
      
      if(j == 0)//     ,
      {
         PrintD("FindYoungerTFObject END2:   " + sName + "     .");//  .
         return("");//   .
      }
      
      ArrayResize(asYoungTLineName, j);//     ,    .
      ArrayResize(asMaxTFObjectName, j);//           .
      k = 0;//       .
      for(i = 0; i < j; i++)
      {
         if(GetTFByColor(ObjectGet(asYoungTLineName[i], OBJPROP_COLOR)) == nMaxTF)//E     ,  
         { 
            asMaxTFObjectName[k] = asYoungTLineName[i];//           (      ).
            k++;//    .
         }
      }
      
      n = 1;//    ,   .
      while(n != 0)//      .         ,      .
      {
         n = 0;//    .
         for(i = 0; i < k-1 ; i++)
         {
            if(nTLDirection * Price_(asMaxTFObjectName[i], 1) > nTLDirection * Price_(asMaxTFObjectName[i+1], 1))//      ,
            {
               sYoungTLineName = asMaxTFObjectName[i];//   .
               asMaxTFObjectName[i] = asMaxTFObjectName[i+1];
               asMaxTFObjectName[i+1] = sYoungTLineName;
               n++;//      .
            }
         }
      }
      if(nObj > k)//      ,
      {
         PrintD("FindYoungerTFObject END3:   " + sName + "      " + nObj +".");//  .
         return("");//   .
      }
      
      sYoungTLineName = asMaxTFObjectName[nObj-1];//,      .
      sYoungObjectName = PIVOT + " " + Object_Number(sYoungTLineName); 
      if(ObjectFind(sYoungObjectName) != -1)//  ,
      {
         PrintD("FindYoungerTFObject END4:  " + nObj + "    " + sName + "  - " + sYoungObjectName + ".");//  .
         return(sYoungObjectName);//   .
      }
      else
      {
         PrintD("FindYoungerTFObject END5:  " + nObj + "    " + sName + "   !");//  .
         return("");//  .
      }   
   }
   PrintD("FindYoungerTFObject END3: sYoungObjectName = " + sYoungObjectName);//  .  
   return(sYoungObjectName);
}
//+--------------------------------------------------------------------------------------+
//      ,    . nShift      .
//, -2     , 1     .
string FindSameTFWave(string sName, int nShift)
{
   int i, j, n, N, nTF, nSize;
   string sSameTFWave, sTempWaveName;
   string asSameTFWave[];
   
   PrintD("FindSameTFWave START: sName = " + sName + ", nShift = " + nShift);//  .  
   if(ObjectType(sName) != OBJ_TREND)//       ,   .
   {
      PrintD("FindSameTFWave END1:      !");//  .  
      return("");
   }

   nTF = GetTFByColor(ObjectGet(sName, OBJPROP_COLOR));//   -     .
   nSize = ObjectsTotal();// .
   ArrayResize(asSameTFWave, nSize);//     .
   j = 0;//   .
   for(i = 0; i < nSize; i++)//     .
   {
      sSameTFWave = ObjectName(i);//  .
      if(GetVATSMFObjectName(sSameTFWave, WAVE_LINE) == "")//     . 
         continue;
      if(GetTFByColor(ObjectGet(sSameTFWave, OBJPROP_COLOR)) != nTF)//     .
         continue;

      asSameTFWave[j] = sSameTFWave;//      .
      j++;//     .
   }

   if(j == 1)//     (    ),
   {
      PrintD("FindSameTFWave END1:   " + sName + "      ");
      return("");//   .
   }
   ArrayResize(asSameTFWave, j);//   .
   sTempWaveName = sName;//    .
   N = MathAbs(nShift);//    .
   n = nShift;//  .
   while(N > 0)//    |1|,       
   {//,     |1|,    ,      ..,    .
      N--;//      .
      sSameTFWave = "";//""   .
      for(i = 0; i < j; i++)//     .
      {
         if(Joint_Coordinates(sTempWaveName, asSameTFWave[i], n) == "")// ,       . 
            continue;
         {
            sSameTFWave = asSameTFWave[i];//   ,       ,    .
            n--;//   ,      .
            sTempWaveName = sSameTFWave;//          |1|.
            break;//       .
         }   
      }
   }

   if(sSameTFWave != "")//   ,
   {
      PrintD("FindSameTFWave END2:   " + sName + "    " + sSameTFWave + "   " + nShift);//  .
      return(sSameTFWave);//,    .
   }
   PrintD("FindSameTFWave END3:   " + sName + "       " + nShift);//  .
   return("");//   ,    .
}
//+--------------------------------------------------------------------------------------+
//         . nShift       .
//, -2         ,           ,
//1              .
string FindElderTFWave(string sName, int nShift)
{
   int i, j, k, N, nTF, nSize;
   string sElderTFWave, sTempName;
   string asElderTFWave[];
   
   PrintD("FindElderTFWave START: sName = " + sName + ", nShift = " + nShift);//  .  
   if(ObjectType(sName) != OBJ_TREND)//       ,   .
   {
      PrintD("FindElderTFWave END1:      !");//  .  
      return("");
   }

   if(nShift == 0)//       ,   .
   {
      PrintD("FindElderTFWave END2:      - nShift=0");//  .  
      return("");
   }
   nSize = ObjectsTotal();// .
   ArrayResize(asElderTFWave, nSize);//     .
   j = 0;//   .
   for(i = 0; i < nSize; i++)//     .
   {
      sElderTFWave = ObjectName(i);//  .
      if(GetVATSMFObjectName(sElderTFWave, WAVE_LINE) == "")//     . 
         continue;
      if(GetTFByColor(ObjectGet(sElderTFWave, OBJPROP_COLOR)) <= GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)))//     .
         continue;
      if(nShift < 0)//      
      {
         if(Joint_Coordinates(sName, sElderTFWave, -1) == "")//           ,
            continue;//   .
      }
      if(nShift > 0)//      
      {
         if(Object_Accommodates(sElderTFWave, sName) == "")//           ,
            continue;//   .
      }
    
      asElderTFWave[j] = sElderTFWave;//      .
      j++;//     .
   }
   ArrayResize(asElderTFWave, j);//   .
   if(j == 0)//    ,
   {
      PrintD("FindElderTFWave END3:   " + sName + "     ");
      return("");//   .
   }
   nTF = 0;
   if(MathAbs(nShift) > j)//      (   , ,      ,       ),
   {
      PrintD("FindElderTFWave END4:   " + sName + "      " + NormalizeDouble(MathAbs(nShift), 0) + " ()");
      return("");//   .
   }
   k = 1;//        
   while(k > 0)
   {   
      k = 0;//     .
      for(i = 0; i < j-1; i++)//        .
      {
         if(GetTFByColor(ObjectGet(asElderTFWave[i], OBJPROP_COLOR)) > GetTFByColor(ObjectGet(asElderTFWave[i+1], OBJPROP_COLOR)))
         {//        ,
            sTempName = asElderTFWave[i];//    .
            asElderTFWave[i] = asElderTFWave[i+1];
            asElderTFWave[i+1] = sTempName;
            k = 1;//  ,     ,        .
         }   
      }
   }
   N = MathAbs(nShift)-1;//     .
   sElderTFWave = asElderTFWave[N];
   PrintD("FindElderTFWave END5:   " + sName + "   " + sElderTFWave + "   " + NormalizeDouble(MathAbs(nShift), 0) + " ()");
   return(sElderTFWave);
}
//+--------------------------------------------------------------------------------------+
//                .
//      . nSide -       .  
//nSide>=-1,   ,  nSide>=1,  - .
string Joint_Coordinates(string sWave1, string sWave2, int nSide )
{
   int n1 = (3 + nSide/MathAbs(nSide))/2;//    .
   int n2 = (3 - nSide/MathAbs(nSide))/2;//    .
   if(((MathAbs(Price_(sWave1, n1) - Price_(sWave2, n2)) < 0.1*MathAbs(Price_(sWave1, 2) - Price_(sWave1, 1)))
    &&(MathAbs(Time_(sWave1, n1) - Time_(sWave2, n2)) < 120*GetTFByColor(ObjectGet(sWave1, OBJPROP_COLOR)))))
   {
      PrintD("Joint_Coordinates END1:  " + sWave1 + "   " + sWave2 + "   .");//  .
      return(sWave2);//   .
   }
   else
   {
      PrintD("Joint_Coordinates END2:  " + sWave1 + "   " + sWave2 + "    ." + Time_(sWave1, n1) + " " + Time_(sWave2, n2));//  .
      return("");//  .
   }
}
//+--------------------------------------------------------------------------------------+
//        , ()  b(C), 4  ,  4  
void CreateNK(string sWaveB)
{
   int i, nNKDirection, nStartBar, nMiddleBar, nEndBar, nMiddle, nWaveCBar;
   double dStartPrice, dMiddlePrice, dEndPrice, dBarPrice, dStartWaveB, dFirstMiddlePrice, dOppositePriceOfBar;
   string sWaveA, sNKName, sWaveBName, sWaveAName;
   datetime dtMiddleTime;
   
   PrintD("CreateNK START: sWaveB = " + sWaveB);//  .
   
   sWaveBName = GetWaveName(sWaveB);//  
   if(sWaveBName == "B" || sWaveBName == "b(C)")//    ""  "b(C)",
      sWaveA = FindSameTFWave(sWaveB, -1);//  -    .

   if(sWaveBName == "4")//   4- ,   ""  "()".
      for(i = 1; i < 6; i++)
      {
         sWaveA = FindSameTFWave(sWaveB, -i);//  ""  "()".
         if(sWaveA == "")//  ,
            break;//  .
         
         if(GetWaveName(sWaveA) == "a(C)"
          ||GetWaveName(sWaveA) == "C")//   
            break;//  .
      }

   if(sWaveA == "")//   ,
   {
      PrintD("CreateNK END1:    " + sWaveB + "    ");//  .
      return;//  .
   }
   dStartPrice = Price_(sWaveA, 1);//  -    .
   nStartBar = iBarShift(NULL, 0, Time_(sWaveA, 1));//   .
   dMiddlePrice = Price_(sWaveB, 2);//  ,    .
   dStartWaveB = dMiddlePrice + 0.88*(Price_(sWaveB, 1) - dMiddlePrice);//88%    ,     88%      .
   nMiddleBar = iBarShift(NULL, 0, Time_(sWaveB, 2));//   .
   Print(nMiddleBar);
   nNKDirection = - Object_Direction(sWaveB);// .
   sNKName = NK + " " + Object_Number(sWaveB);// .
   
   if(ObjectFind(sNKName) != -1 )
   {
      SetObjectColor(sNKName, ObjectGet(sWaveB, OBJPROP_COLOR));//    .
      PrintD("CreateNK END2:    " + sWaveB + "   " + sNKName);//  .
      return;
   }
   
   ObjectCreate(sNKName, OBJ_TREND, 0, Time_(sWaveA, 1), dStartPrice, iTime(NULL, 0, nMiddleBar), dMiddlePrice);//      ,   .
   SetObjectColor(sNKName, ObjectGet(sWaveB, OBJPROP_COLOR));//    .
   ObjectSet(sNKName, OBJPROP_RAY, false);//    .
   ObjectSet(sNKName, OBJPROP_BACK, true);//   .
   ObjectSet(sNKName, OBJPROP_WIDTH, 1);//  .
   ObjectSet(sNKName, OBJPROP_STYLE, STYLE_DOT);//  .
   ObjectSetText(sNKName, dMiddlePrice + " " + TimeToStr(Time_(sWaveB, 2)));//          .
   
   
   dFirstMiddlePrice = dMiddlePrice;//    ,      .
   nMiddle = nMiddleBar - 1;//         .
   nEndBar = 0;//    ,        .
   nWaveCBar = 0;//        (,        B)
   for(i = nMiddle; i >= 0; i--)//      .
   {
      if(nNKDirection == 1)//   ,
      {
         dBarPrice = iLow(NULL, 0, i);//         
         dOppositePriceOfBar = iHigh(NULL, 0, i);//        .
      }
      else//   ,
      {
         dBarPrice = iHigh(NULL, 0, i);//         
         dOppositePriceOfBar = iLow(NULL, 0, i);//        .
      }

      dEndPrice = (dMiddlePrice - dStartPrice)*(i - nStartBar)/(nMiddleBar - nStartBar) + dStartPrice;//      .
      if(MathAbs(dFirstMiddlePrice - dStartWaveB) != MathAbs(dFirstMiddlePrice - dOppositePriceOfBar) + MathAbs(dStartWaveB - dOppositePriceOfBar)
         && nWaveCBar == 0)// ,     .
         nWaveCBar = i;//   .

      if(nNKDirection*dBarPrice > nNKDirection*dEndPrice)//    ,
         continue;//    ,

      if(nWaveCBar == 0 || nWaveCBar == i)//          ,
      {
         dMiddlePrice = dBarPrice;//    
         nMiddleBar = i;//   .
         dtMiddleTime = GetExectTLTime(iTime(NULL, 0, i), dMiddlePrice, - nNKDirection);//   .
         ObjectSet(sNKName, OBJPROP_PRICE2, dMiddlePrice);//      
         ObjectSet(sNKName, OBJPROP_TIME2, dtMiddleTime);//      .
         ObjectSetText(sNKName, dMiddlePrice + " " + TimeToStr(dtMiddleTime));//          .
         continue;//   .
      }
      else
      {
         nEndBar = i;//,        
         break;//   ,     .
      }
   }
   if(nEndBar != 0)//   ,
      ObjectSet(sNKName, OBJPROP_STYLE, STYLE_DASHDOT);//   , ,   .
   ObjectSet(sNKName, OBJPROP_PRICE2, dEndPrice);//   
   ObjectSet(sNKName, OBJPROP_TIME2, iTime(NULL, 0,nEndBar));// .

   
   if(sWaveBName == "4")//   4- ,
   {
      sWaveA = FindSameTFWave(sWaveA, -2);//     "".
      if(sWaveA == "")//   ,
      {
         PrintD("CreateNK END3:    " + sWaveB + "    ");//  .
         return;//  .
      }
      dStartPrice = Price_(sWaveA, 1);//  -    .
      nStartBar = iBarShift(NULL, 0, Time_(sWaveA, 1));//   .
      dMiddlePrice = Price_(sWaveB, 2);//  ,    .
      dStartWaveB = dMiddlePrice + 0.88*(Price_(sWaveB, 1) - dMiddlePrice);//88%    ,     88%      .
      nMiddleBar = iBarShift(NULL, 0, Time_(sWaveB, 2));//   .
      nNKDirection = - Object_Direction(sWaveB);// .
      sNKName = NK + " " + Object_Number(sWaveB)+1;// .
   
      if(ObjectFind(sNKName) != -1 )
      {
         SetObjectColor(sNKName, ObjectGet(sWaveB, OBJPROP_COLOR));//    .
         PrintD("CreateNK END4:    " + sWaveB + "   " + sNKName);//  .
         return;
      }
   
      ObjectCreate(sNKName, OBJ_TREND, 0, Time_(sWaveA, 1), dStartPrice, iTime(NULL, 0, nMiddleBar), dMiddlePrice);//      ,   .
      SetObjectColor(sNKName, ObjectGet(sWaveB, OBJPROP_COLOR));//    .
      ObjectSet(sNKName, OBJPROP_RAY, false);//    .
      ObjectSet(sNKName, OBJPROP_BACK, true);//   .
      ObjectSet(sNKName, OBJPROP_WIDTH, 1);//  .
      ObjectSet(sNKName, OBJPROP_STYLE, STYLE_DOT);//  .
      ObjectSetText(sNKName, dMiddlePrice + " " + TimeToStr(Time_(sWaveB, 2)));//          .
   
   
      dFirstMiddlePrice = dMiddlePrice;//    ,      .
      nMiddle = nMiddleBar - 1;//         .
      nEndBar = 0;//    ,        .
      nWaveCBar = 0;//        (,        B)
      for(i = nMiddle; i >= 0; i--)//      .
      {
         if(nNKDirection == 1)//   ,
         {
            dBarPrice = iLow(NULL, 0, i);//         
            dOppositePriceOfBar = iHigh(NULL, 0, i);//        .
         }
         else//   ,
         {
            dBarPrice = iHigh(NULL, 0, i);//         
            dOppositePriceOfBar = iLow(NULL, 0, i);//        .
         }

         dEndPrice = (dMiddlePrice - dStartPrice)*(i - nStartBar)/(nMiddleBar - nStartBar) + dStartPrice;//      .
         if(MathAbs(dFirstMiddlePrice - dStartWaveB) != MathAbs(dFirstMiddlePrice - dOppositePriceOfBar) + MathAbs(dStartWaveB - dOppositePriceOfBar)
            && nWaveCBar == 0)// ,     .
            nWaveCBar = i;//   .

         if(nNKDirection*dBarPrice > nNKDirection*dEndPrice)//    ,
            continue;//    ,

         if(nWaveCBar == 0 || nWaveCBar == i)//          ,
         {
            dMiddlePrice = dBarPrice;//    
            nMiddleBar = i;//   .
            dtMiddleTime = GetExectTLTime(iTime(NULL, 0, i), dMiddlePrice, - nNKDirection);//   .
            ObjectSet(sNKName, OBJPROP_PRICE2, dMiddlePrice);//      
            ObjectSet(sNKName, OBJPROP_TIME2, dtMiddleTime);//      .
            ObjectSetText(sNKName, dMiddlePrice + " " + TimeToStr(dtMiddleTime));//          .
            continue;//   .
         }
         else
         {
            nEndBar = i;//,        
            break;//   ,     .
         }
      }
      if(nEndBar != 0)//   ,
         ObjectSet(sNKName, OBJPROP_STYLE, STYLE_DASHDOT);//   , ,   .
      ObjectSet(sNKName, OBJPROP_PRICE2, dEndPrice);//   
      ObjectSet(sNKName, OBJPROP_TIME2, iTime(NULL, 0,nEndBar));// .
   }
   
   PrintD("CreateNK END5:    " + sWaveB + "   " + sNKName);//  .
   return;
}