//+------------------------------------------------------------------+
//|                                              Object_SaveLoad.mq4 |
//|                                        Copyright 2013, xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+

#include <TFColor.mqh>
#include <TFColorFunctions.mqh>
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int i, hFile, nReturn, nObjectType, nFiboType;
   string sName, sFileName;
   
   nReturn = MessageBox("\"\" -  . \n\"\" -  . \n\"\" - .","/ ", MB_YESNOCANCEL|MB_ICONINFORMATION);
   if(nReturn == IDYES)
   {
      sFileName = "link_charts_"+Symbol()+".csv";
      hFile = FileOpen(sFileName, FILE_CSV|FILE_WRITE,";");//    
   
      for(i=0; i < ObjectsTotal(); i++)
      {
         sName = ObjectName(i);// 
      
         if(GetVATSMFObjectName(sName, ALL) == "")//     .
            continue;
         if(ObjectType(sName) == OBJ_TREND)//    
            FileWrite(hFile, sName, ObjectType(sName), ObjectGet(sName, OBJPROP_TIME1), ObjectGet(sName, OBJPROP_PRICE1), ObjectGet(sName, OBJPROP_TIME2), ObjectGet(sName, OBJPROP_PRICE2), ObjectGet(sName, OBJPROP_COLOR), ObjectGet(sName, OBJPROP_BACK), ObjectGet(sName, OBJPROP_TIMEFRAMES), ObjectGet(sName, OBJPROP_WIDTH), ObjectGet(sName, OBJPROP_STYLE), ObjectGet(sName, OBJPROP_RAY), ObjectDescription(sName));//      .
         if(ObjectType(sName) == OBJ_FIBO)// 
            FileWrite(hFile, sName, ObjectType(sName), ObjectGet(sName, OBJPROP_TIME1), ObjectGet(sName, OBJPROP_PRICE1), ObjectGet(sName, OBJPROP_TIME2), ObjectGet(sName, OBJPROP_PRICE2), ObjectGet(sName, OBJPROP_COLOR), ObjectGet(sName, OBJPROP_BACK), ObjectGet(sName, OBJPROP_TIMEFRAMES), ObjectGet(sName, OBJPROP_WIDTH), ObjectGet(sName, OBJPROP_STYLE), ObjectGet(sName, OBJPROP_RAY),ObjectGet(sName, OBJPROP_LEVELCOLOR),ObjectGet(sName, OBJPROP_LEVELSTYLE),ObjectGet(sName, OBJPROP_LEVELWIDTH), IsFiboImpulse(sName));//    .
         if(ObjectType(sName) == OBJ_TEXT)//   
            FileWrite(hFile, sName, ObjectType(sName), ObjectGet(sName, OBJPROP_TIME1), ObjectGet(sName, OBJPROP_PRICE1), ObjectGet(sName, OBJPROP_COLOR), ObjectGet(sName, OBJPROP_BACK), ObjectGet(sName, OBJPROP_TIMEFRAMES), ObjectDescription(sName), ObjectGet(sName, OBJPROP_FONTSIZE));//     .
         if(ObjectType(sName) == OBJ_RECTANGLE)//   
            FileWrite(hFile, sName, ObjectType(sName), ObjectGet(sName, OBJPROP_TIME1), ObjectGet(sName, OBJPROP_PRICE1), ObjectGet(sName, OBJPROP_TIME2), ObjectGet(sName, OBJPROP_PRICE2), ObjectGet(sName, OBJPROP_COLOR), ObjectGet(sName, OBJPROP_BACK), ObjectGet(sName, OBJPROP_TIMEFRAMES), ObjectGet(sName, OBJPROP_WIDTH), ObjectGet(sName, OBJPROP_STYLE), ObjectDescription(sName));//      .
         if(ObjectType(sName) == OBJ_ARROW)// 
            FileWrite(hFile, sName, ObjectType(sName), ObjectGet(sName, OBJPROP_TIME1), ObjectGet(sName, OBJPROP_PRICE1), ObjectGet(sName, OBJPROP_COLOR), ObjectGet(sName, OBJPROP_BACK), ObjectGet(sName, OBJPROP_TIMEFRAMES), ObjectGet(sName, OBJPROP_WIDTH), ObjectGet(sName, OBJPROP_ARROWCODE), ObjectDescription(sName));//    .
      }

      FileClose(hFile);// .
   }
   if(nReturn == IDNO)
   {
      sFileName = "link_charts_"+Symbol()+".csv";
      hFile = FileOpen(sFileName, FILE_CSV|FILE_READ,";");//    
      if(hFile == -1)//    ,
      {
         Alert("    !   .");
         return(0);//   .
      }
      while(!FileIsEnding(hFile))
      {
         sName = FileReadString(hFile);//  .
         if(ObjectFind(sName) != -1)//       ,
         {
            while(!FileIsLineEnding(hFile))//     
               FileReadString(hFile);
            continue;//      .
         }
         nObjectType = FileReadNumber(hFile);//  .
         switch(nObjectType)
         {
         case OBJ_TREND: //    
            ObjectCreate(sName, nObjectType,0,FileReadNumber(hFile),StrToDouble(FileReadString(hFile)),FileReadNumber(hFile),StrToDouble(FileReadString(hFile)));
            ObjectSet(sName, OBJPROP_COLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_BACK, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_TIMEFRAMES, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_WIDTH, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_STYLE, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_RAY, FileReadNumber(hFile));
            ObjectSetText(sName, FileReadString(hFile));
            break;
         case OBJ_FIBO:// 
            ObjectCreate(sName, nObjectType,0,FileReadNumber(hFile),StrToDouble(FileReadString(hFile)),FileReadNumber(hFile),StrToDouble(FileReadString(hFile)));
            ObjectSet(sName, OBJPROP_COLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_BACK, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_TIMEFRAMES, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_WIDTH, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_STYLE, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_RAY, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_LEVELCOLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_LEVELSTYLE, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_LEVELWIDTH, FileReadNumber(hFile));
            nFiboType = FileReadNumber(hFile);//    .
            if(nFiboType == 1)
               MakeFiboImpulse(sName);
            if(nFiboType == -1)
               MakeFiboCorrection(sName);
            if(nFiboType == 0)
               MakeFiboNormal(sName);
            break;
         case OBJ_TEXT://   
            ObjectCreate(sName, nObjectType,0,FileReadNumber(hFile),StrToDouble(FileReadString(hFile)));
            ObjectSet(sName, OBJPROP_COLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_BACK, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_TIMEFRAMES, FileReadNumber(hFile));
            ObjectSetText(sName,FileReadString(hFile),FileReadNumber(hFile));//     .
            break;
         case OBJ_RECTANGLE://   
            ObjectCreate(sName, nObjectType,0,FileReadNumber(hFile),StrToDouble(FileReadString(hFile)),FileReadNumber(hFile),StrToDouble(FileReadString(hFile)));
            ObjectSet(sName, OBJPROP_COLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_BACK, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_TIMEFRAMES, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_WIDTH, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_STYLE, FileReadNumber(hFile));
            ObjectSetText(sName, FileReadString(hFile));
            break;
         case OBJ_ARROW:// 
            ObjectCreate(sName, nObjectType,0,FileReadNumber(hFile),StrToDouble(FileReadString(hFile)));
            ObjectSet(sName, OBJPROP_COLOR, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_BACK, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_TIMEFRAMES, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_WIDTH, FileReadNumber(hFile));
            ObjectSet(sName, OBJPROP_ARROWCODE, FileReadNumber(hFile));
            ObjectSetText(sName,FileReadString(hFile));
            break;
         }
      }
   }
   return(0);
}
//+------------------------------------------------------------------+