//+------------------------------------------------------------------+
//|                                               CreateTFColors.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//        ,  ,
//           -.
//+------------------------------------------------------------------+


#include <TFColor.mqh>
#include <TFColorFunctions.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int i, x, nStep, nNumNameLetters;
   string sTF;
   color clTF;
   string asProperties[11]={"", "", "", "", "", "", "", "", "", "", ""};
   
   asProperties[10] = "1";//  " ".
   Link(asProperties);//   .

   int nSize = ArraySize(ALL_TF);

   if (ObjectFind("COLOR_" + GetTFName(ALL_TF[0])) == 0)   
   {
      for(i=(nSize-1);i >=0; i--)
      {
         sTF = GetTFName(ALL_TF[i]);
         
         ObjectDelete("COLOR_" + sTF);
      }      
   }
   else
   {
      nStep = GlobalVariableGet("FontSize");
      if(nStep == 0)
      {
         nStep = 10;
         GlobalVariableSet("FontSize", 10);
      }
      x = COLORS_LEFT_POS;
      for(i = 0; i < nSize; i++)
      {
         clTF = GetColorByTF(ALL_TF[i]);
         sTF = GetTFName(ALL_TF[i]);
         CreateText( "COLOR_" + sTF, x,  COLORS_TOP_POS, sTF, clTF);
         nNumNameLetters = StringLen(sTF);
         x = x + nStep*nNumNameLetters;
      }      
   }
   
      
   WindowRedraw();
}

//+------------------------------------------------------------------+

void CreateText( string sName, int x, int y, string sLetter, color clColor )
{
   ObjectDelete(sName);

   if ( ObjectCreate	( sName, OBJ_LABEL, 0, 0, 0 ) )
   {
      ObjectSetText	( sName, sLetter, GlobalVariableGet("FontSize"), FontFace(), clColor );
      ObjectSet(sName, OBJPROP_CORNER, 0);
      ObjectSet(sName, OBJPROP_XDISTANCE, x);
      ObjectSet(sName, OBJPROP_YDISTANCE, y);
      ObjectSet(sName, OBJPROP_BACK, true);
   }
   
   GetLastError();
}
//+------------------------------------------------------------------+

